; *****************************
; ** angelZware PB Tools Lib **
; ** ----------------------- **
; ** file_demo.pb            **
; ** V0.1 (2010/08/23)       **
; ** by Ronny Krger         **
; *****************************
; ** Licence: LGPL V3        **
; *****************************

EnableExplicit


CompilerSelect #PB_Compiler_OS 
  CompilerCase #PB_OS_Windows
    IncludePath "..\include\awpbtools"
  CompilerCase #PB_OS_Linux
    IncludePath "../include/awpbtools"
CompilerEndSelect

XIncludeFile "awfile.pbi"

OpenConsole()

PrintN("AWPB-Tools File-Demo")
PrintN("")

Global filename.s, fid.i, fid2.i, hdr.s

filename.s = "filedemo.dat"
fid.i = AWPB_FILE_CreateFile(filename, "TEST")
If fid
  AWPB_FILE_WriteByteHdr(fid, "BYTE", $ab)
  AWPB_FILE_WriteLongHdr(fid, "LONG", $abc00cba)
  AWPB_FILE_WriteQuadHdr(fid, "QUAD", $abcdef0000fedcba)
  AWPB_FILE_WriteWordHdr(fid, "WORD", $abba)
  AWPB_FILE_WriteStringHdr(fid, "STR ", "aaaaaaEin Standard-Teststring. Sollte im Hex-Editor nicht im Klartext zu sehen sein, da gepackt!aaaaaa")
  AWPB_FILE_WriteStringHdr(fid, "STR ", "bbbbbbEin Standard-Teststring. Sollte im Hex-Editor nicht im Klartext zu sehen sein, da gepackt!bbbbbb")
  AWPB_FILE_WriteStringHdr(fid, "STR ", "ccccccEin Standard-Teststring. Sollte im Hex-Editor nicht im Klartext zu sehen sein, da gepackt!cccccc")
  AWPB_FILE_WriteStringHdr(fid, "STR ", "ddddddEin Standard-Teststring. Sollte im Hex-Editor nicht im Klartext zu sehen sein, da gepackt!dddddd")
  AWPB_FILE_WriteStringHdr(fid, "STR ", "eeeeeeEin Standard-Teststring. Sollte im Hex-Editor nicht im Klartext zu sehen sein, da gepackt!eeeeee")
  AWPB_FILE_WriteStringHdr(fid, "STR ", "ffffffEin Standard-Teststring. Sollte im Hex-Editor nicht im Klartext zu sehen sein, da gepackt!ffffff")
  AWPB_FILE_WriteStringHdr(fid, "STR ", "ggggggEin Standard-Teststring. Sollte im Hex-Editor nicht im Klartext zu sehen sein, da gepackt!gggggg")
  AWPB_FILE_WriteWordHdr(fid, "XXXX", $abba)
  AWPB_FILE_WriteStringHdr(fid, "STR ", "Ein unkomprimierter UNICODE Teststring. ", #PB_Unicode, #AWPB_ZIP_COMP_NONE)
  AWPB_FILE_WriteStringHdr(fid, "STR ", "Ein unkomprimierter UTF8 Teststring. ", #PB_UTF8, #AWPB_ZIP_COMP_NONE)
  AWPB_FILE_WriteStringHdr(fid, "STR ", "Ein unkomprimierter ASCII Teststring. ", #PB_Ascii, #AWPB_ZIP_COMP_NONE)
  AWPB_FILE_FinishFile(fid)
  
  fid2 = AWPB_FILE_ReadFile(filename, "ABCD")     ; sollte wegen header fehlschlagen
  If Not IsFile(fid2)
    PrintN("Datei nicht geffnet, Header passt nicht")
  Else
    AWPB_FILE_closefile(fid2)
  EndIf
  fid2 = AWPB_FILE_ReadFile(filename, "TEST")
  If IsFile(fid2)
    PrintN("Datei offen ... lese Daten")
    While Not Eof(fid2)
      hdr = AWPB_FILE_ReadHeader(fid2)
      PrintN("Header gefunden: " + hdr)
      If hdr = "LONG"
        AWPB_FILE_readblocksize(fid2)   ; wird hier nicht gebraucht, muss aber wegen der genutzten PB-API-Funktion ReadLong() aufgerufen werden
        PrintN("Gelesen: " + Hex(ReadLong(fid2), #PB_Long) + " Erwartet: $abc00cba")
      ElseIf hdr = "WORD"
        AWPB_FILE_readblocksize(fid2)   ; wird hier nicht gebraucht, muss aber wegen der genutzten PB-API-Funktion ReadWord() aufgerufen werden
        PrintN("Gelesen: " + Hex(ReadWord(fid2), #PB_Word) + " Erwartet: $abba")
      ElseIf hdr = "BYTE"
        AWPB_FILE_readblocksize(fid2)   ; wird hier nicht gebraucht, muss aber wegen der genutzten PB-API-Funktion ReadByte() aufgerufen werden
        PrintN("Gelesen: " + Hex(ReadByte(fid2), #PB_Byte) + " Erwartet: $ab")
      ElseIf hdr = "QUAD"
        AWPB_FILE_readblocksize(fid2)   ; wird hier nicht gebraucht, muss aber wegen der genutzten PB-API-Funktion ReadQuad() aufgerufen werden
        PrintN("Gelesen: " + Hex(ReadQuad(fid2), #PB_Quad) + " Erwartet: $abcdef0000fedcba")
      ElseIf hdr = "STR "
        ; AWPB_FILE_readblocksize() darf hier nicht aufgerufen werden, da keine pb-api-funktion zum lesen genommen wird
        PrintN("Gelesen: >" + AWPB_FILE_ReadString(fid2) + "<")
      ElseIf hdr = "EOF."
        ; empfohlene Art, das Ende abzufangen
        PrintN("Dateiende erreicht") 
        Break
      Else
        AWPB_FILE_SkipBlock(fid2)   ; Block berspringen
        PrintN("Header unbekannt")  ; muss bei XXXX anspringen
      EndIf
    Wend
    AWPB_FILE_CloseFile(fid2)
  Else
    PrintN("Konnte datei nicht ffnen")  
  EndIf
Else
  PrintN("Kann Datei nicht erstellen!")  
EndIf


PrintN("Press return to exit")
Input()
; IDE Options = PureBasic 4.51 (Windows - x64)
; ExecutableFormat = Console
; CursorPosition = 50
; FirstLine = 21
; EnableUnicode
; EnableThread
; EnableXP
; Executable = file_demo
; CPU = 1
; Compiler = PureBasic 4.51 RC 2 (Linux - x64)
; EnablePurifier