; *****************************
; ** angelZware PB Tools Lib **
; ** ----------------------- **
; ** maildec_demo.pb         **
; ** V0.1 (2010/08/23)       **
; ** by Ronny Krger         **
; *****************************
; ** Licence: LGPL V3        **
; *****************************

EnableExplicit

; Maildecoder-Demo, zerlegt eine Mail und speichert die anhnge ab

CompilerSelect #PB_Compiler_OS 
  CompilerCase #PB_OS_Windows
    IncludePath "..\include\awpbtools"
  CompilerCase #PB_OS_Linux
    IncludePath "../include/awpbtools"
CompilerEndSelect

XIncludeFile "awmessage.pbi"

OpenConsole()

PrintN("MailDekoder-Demo")
PrintN("")

Global *msg, *part, file.s, attcount.i, folder.s
NewList atts.i()

file = OpenFileRequester("Mail auswhlen", "", "EML-Files (*.EML)|*.EML", 0)
If file
  Print("Loading mail ... ")
  *msg = AWPB_MSG_LoadMailEML(#Null, file)
  If *msg
    PrintN("success")     
    PrintN("Decoding ... ")
    If AWPB_MSG_DecodeMessage(*msg)
      PrintN("success" )
      PrintN("From:            >" + AWPB_MSG_GetFrom(*msg) + "<")
      PrintN("To:              >" + AWPB_MSG_GetTo(*msg) + "<")
      PrintN("To (adr only):   >" + AWPB_MSG_GetToMails(*msg) + "<")
      PrintN("CC:              >" + AWPB_MSG_GetCC(*msg) + "<")
      PrintN("CC (adr only):   >" + AWPB_MSG_GetCCMails(*msg) + "<")
      PrintN("Date:            >" + FormatDate("%dd.%mm.%yyyy %hh:%ii:%ss", AWPB_MSG_GetDate(*msg)) + "<")    
      PrintN("Date RFC:        >" + ____MSG_GetDateStr(*msg) + "<")   
      PrintN("Subject:         >" + AWPB_MSG_GetSubject(*msg) + "<")
      PrintN("Lnge HTML Body: >" + Str(Len(AWPB_MSG_GetHTMLBody(*msg))) + "<")
      PrintN("Lnge Text Body: >" + Str(Len(AWPB_MSG_GetPlainBody(*msg))) + "<")
      Print("Building Attachment-List ... ")
      attcount = AWPB_MSG_GetAttachmentList(*msg, atts())
      PrintN("done")
      PrintN("Found " + Str(attcount) + " attachments")
      If attcount
        ForEach atts()
          *part = atts()
          If *part
            PrintN("Found Attachment Name: " + AWPB_MSG_GetContentName(*part) + " / Filename: " + AWPB_MSG_GetContentFilename(*part))
          EndIf
        Next
        folder = PathRequester("Save Attachments to", GetCurrentDirectory())
        If folder
          Print("Saving ... ")
          If AWPB_MSG_SaveAttachmentsToFolder(atts(), folder)
            PrintN("success")
          Else
            PrintN("failed")
          EndIf
        EndIf
      EndIf
    Else
      PrintN("failed")
    EndIf
    
    AWPB_MSG_FreeMessage(*msg)
  Else
    PrintN("failed")
  EndIf
EndIf
  
  
PrintN("Press return to exit")
Input()

; IDE Options = PureBasic 4.51 RC 2 (Windows - x64)
; CursorPosition = 48
; FirstLine = 30
; EnableUnicode
; EnableThread
; EnableXP
; Executable = file_demo.exe
; CPU = 1
; Compiler = PureBasic 4.51 RC 2 (Windows - x86)
; EnablePurifier