; *****************************
; ** angelZware PB Tools Lib **
; ** ----------------------- **
; ** pop3_demo.pb         **
; ** V0.1 (2010/08/23)       **
; ** by Ronny Krger         **
; *****************************
; ** Licence: LGPL V3        **
; *****************************

EnableExplicit


CompilerSelect #PB_Compiler_OS 
  CompilerCase #PB_OS_Windows
    IncludePath "..\include\awpbtools"
  CompilerCase #PB_OS_Linux
    IncludePath "../include/awpbtools"
CompilerEndSelect

XIncludeFile "awpop3.pbi"
XIncludeFile "awmessage.pbi"

Global *pop, *msg, msgsrc.s, attcount.i, folder.s
NewList atts.i()

InitNetwork()     ;- fr pop3 ntig
OpenConsole()

PrintN("AWPB-Tools POP3-Demo")
PrintN("")

Print("Allocation POP3 Object ... ")
*pop = AWPB_POP3_AllocatePOP3()
If *pop
  PrintN("success")
  Print("Allocations Message Object ... ")
  *msg = AWPB_MSG_AllocateMessage()
  If *msg
    PrintN("success")
    AWPB_POP3_SetServer(*pop, "pop.gmx.net", 110)   ;- Set     Hier POP3-Server und Port eintragen
    AWPB_POP3_SetLogin(*pop, "LOGIN", "PASSWORT")   ;- Set     Hier Loginnamen und Passwort eintragen
    Print("Connecting ... ")
    If AWPB_POP3_Connect(*pop)
      PrintN("success")
      Print("Retrieving Message 1 ... ")
      msgsrc = AWPB_POP3_RETR(*pop, 1)
      If msgsrc
        PrintN("success - Length: " + Str(Len(msgsrc)))
        PrintN("Parsing Message")
        *msg = AWPB_MSG_SetMailSource(*msg, msgsrc)
        If *msg
          If AWPB_MSG_SaveMailEML(*msg, "pop3message.eml")
            PrintN("Mail saved")
          Else
            PrintN("mail not saved")
          EndIf     
        Else
          PrintN("SetMailSource failed")
        EndIf
      Else
        PrintN("Fehler beim Mailabruf")
        PrintN("Server replied: " + AWPB_POP3_GetServerResult(*pop))
      EndIf
      AWPB_POP3_DisConnect(*pop)
    Else
      PrintN("failed")
      PrintN("Server replied: " + AWPB_POP3_GetServerResult(*pop))
    EndIf
    AWPB_MSG_FreeMessage(*msg)
  Else
    PrintN("failed")
  EndIf
  AWPB_POP3_FreePOP3(*pop)
Else
  PrintN("failed")
EndIf

PrintN("Press return to exit")
Input()

; IDE Options = PureBasic 4.51 RC 2 (Windows - x64)
; CursorPosition = 41
; FirstLine = 26
; EnableUnicode
; EnableThread
; EnableXP
; Executable = file_demo.exe
; CPU = 1
; Compiler = PureBasic 4.51 RC 2 (Windows - x64)
; EnablePurifier