; *****************************
; ** angelZware PB Tools Lib **
; ** ----------------------- **
; ** awmessage.pbi           **
; ** V0.3 (2010/08/26)       **
; ** by Ronny Krger         **
; *****************************
; ** Licence: LGPL V3        **
; *****************************

;**
;* awmessage.pbi_
;* Version 0.3_
;* _
;* eMail En-/Decoder fr PureBasic 4.50+_
;* Lizenz: LGPL V3_
;* _
;* Systemanforderungen:_
;* <table style="text-align: left;" border="0" cellpadding="2" cellspacing="0"><tbody><tr>
;* <td style="vertical-align: top;">Windows</td><td style="vertical-align: top;">[x]</td>
;* <td style="vertical-align: top;">Linux</td><td style="vertical-align: top;">[x]</td>
;* <td style="vertical-align: top;">Mac</td><td style="vertical-align: top;">[ ]</td></tr><tr>
;* <td style="vertical-align: top;">x86</td><td style="vertical-align: top;">[x]</td>
;* <td style="vertical-align: top;">x64</td><td style="vertical-align: top;">[x]</td>
;* <td style="vertical-align: top;">PPC</td><td style="vertical-align: top;">[ ]</td></tr><tr>
;* <td style="vertical-align: top;">ASCII</td><td style="vertical-align: top;">[x]</td>
;* <td style="vertical-align: top;">Unicode</td><td style="vertical-align: top;">[x]</td>
;* <td style="vertical-align: top;"></td><td style="vertical-align: top;"></td></tr></tbody></table>

XIncludeFile "awsupport.pbi"
XIncludeFile "awfile.pbi"
XIncludeFile "awdate.pbi"
 
;{ constants
; Content-Types
#____MSG_TYPE_PLAIN       = 1
#____MSG_TYPE_HTML        = 2
#____MSG_TYPE_RELATED     = 3
#____MSG_TYPE_MIXED       = 4
#____MSG_TYPE_ALTERNATIVE = 5
#____MSG_TYPE_BINARY      = 6
#____MSG_TYPE_ATTACHMENT  = 7
#____MSG_TYPE_INLINE      = 8

; Encodings
#____MSG_ENCODE_AUTO      = 0
#____MSG_ENCODE_QP        = 1
#____MSG_ENCODE_B64       = 2

; Priorities
#____MSG_PRIORITY_HIGHEST = 1
#____MSG_PRIORITY_HIGH    = 2
#____MSG_PRIORITY_NORMAL  = 3
#____MSG_PRIORITY_LOW     = 4
#____MSG_PRIORITY_LOWEST  = 5

; Charsets
#____MSG_CHARSET_UNKNOWN      = 0
#____MSG_CHARSET_ISO_8859_15  = 1
;}
;{ structures
Structure ____MSG_HeaderField             ; HeaderField
  key.s                                    ; Key, also das was vorm : bezw vom = steht
  value.s                                  ; der jeweilige Eintrag, max bis zum ;
EndStructure
Structure ____MSG_Header
  Map dat.____MSG_HeaderField()           ; Eine Headerzeile = eine Map von Eintrgen
EndStructure
Structure ____MSG_MimePart
  Map  Header.____MSG_Header()            ; Message Header (alle Headerzeilen dieses Parts)
  List MimePart.____MSG_MimePart()        ; Message SubParts (sofern multipart, alle subparts darin)
  body.i                                  ; Pointer to BodyData, RAW - including all CR/LF
  bodylen.i                               ; Length of BodyData in bytes (including all CR/LF)
  justptr.b                               ; if false FreeMem, if true body is part of msg-src
EndStructure
Structure ____MSG_Message Extends ____MSG_MimePart
  src.i                                   ; source, ascii-format, 1 byte / char, with CR/LF
  bcc.s                                   ; BCC Empfngerliste
  decoded.b                               ; Flag, #True wenn dekodiert, sonst #False
EndStructure
;}
;{ macros
Macro ____MSG_GetHeaderValue(res, msgpart, key1, key2)      ; Header= ABCD: DEF; GHI=JKL; - ABCD = Key1, GHI = Key2; JKL wird zurckgegeben
  res = ""
  If FindMapElement(msgpart\Header(), key1)
    If FindMapElement(msgpart\Header()\dat(), key2)
      res = msgpart\Header()\dat()\value
    EndIf
  EndIf
EndMacro
Macro ____MSG_GetHeaderData(res, msgpart, key1)              ; Header= ABCD: DEF; GHI=JKL; - ABCD = Key1, DEF wird zurckgegeben
  ____MSG_GetHeaderValue(res, msgpart, key1, key1)
EndMacro
;}
;{ support procedures
Procedure.b ____MSG_NeedQuotes(txt.s)                                   ; Test, ob der bergebene String in "" eingeschlossen werden muss
  Protected c.c, *a, i.i, l.i
  
  *a = @txt
  l  = Len(txt)
  If (PeekC(*a) = 34) And (PeekC(*a + l - 1) = 34)
    ; already surrounded by quotes
    ProcedureReturn #False
  EndIf
  For i = 1 To l
    c = PeekC(*a) : *a + SizeOf(c)
    If Not (((c >= 'A') And (c <= 'Z')) Or ((c >= 'a') And (c <= 'z')) Or ((c >= '0') And (c <= '9')))
      ProcedureReturn #True
    EndIf
  Next
  
  ProcedureReturn #False
EndProcedure
Procedure.s ____MSG_AddQuotesIfNeeded(txt.s)                            ; falls der bergebene String in "" eingeschlossen werden muss dieses tun und das ergebnis zurckgeben
  If ____MSG_NeedQuotes(txt)
    txt = Chr(34) + txt + Chr(34)
  EndIf
  ProcedureReturn txt
EndProcedure    
Procedure.b ____MSG_NeedEncoding(text.s, ignorews.b = #True)            ; Test, ob der Text kodiert werden muss, also ob er fr 7-Bit eMails ungltige Zeichen enthlt
  Protected *a, i.i, c.c
  
  *a  = @text
  For i = 1 To Len(text)
    c = PeekC(*a)
    If ignorews
      If (c > 126) Or ((c < 32) And (c <> 9)) Or (c = 34)
        ProcedureReturn #True
      EndIf
    Else
      If (c > 126) Or (c < 33) Or (c = 34)
        ProcedureReturn #True
      EndIf
    EndIf
    *a + SizeOf(c)
  Next
  
  ProcedureReturn #False
EndProcedure
Procedure.i ____MSG_CountCharsToEncode(text.s, encodews.b = #True)      ; Anzahl der Zeichen, die QP-Encoded werden mssen ermitteln
  Protected *b, i.i, l.i, c.c, cnt.i
  
  l   = Len(text)
  *b  = @text
  cnt = 0
  For i = 1 To l
    c = PeekA(*b) : *b + 1
    If (c < 33) Or (c > 126) Or (c = 61) Or (c = '!') Or (c = '"') Or (c = '#') Or (c = '$') Or (c = '@') Or (c = '[') Or (c = '\') Or (c = ']') Or (c = '^') Or (c = '`') Or (c = '{') Or (c = '|') Or (c = '}') Or (c = '~')
      If (c = 9) Or (c = 32)
        If (PeekA(*b) = $0d) Or (PeekA(*b - 2) = $0a) Or encodews
          cnt + 1
        EndIf           
      Else
        If (c <> 10) And (c <> 13)
          cnt + 1
        EndIf
      EndIf
    EndIf
  Next i
  
  ProcedureReturn cnt
EndProcedure  
Procedure.i ____MSG_MaxCharCountForQPLineLen(text.s, linelen.i, startpos.i, encodews.b = #True)   ; maximale Anzahl der Zeichen ermitteln, die in eine Zeile codiert werden knnen
  Protected *b, len.i, c.c, cnt.i, tl.i
  
  tl  = Len(text)
  cnt = 0
  If startpos < tl
    *b  = @text + ((startpos - 1) * SizeOf(c))
    len = 0
    tl  - startpos + 1
    While tl > 0
      c = PeekC(*b)
      If (c < 33) Or (c > 126) Or (c = 61) Or (c = '!') Or (c = '"') Or (c = '#') Or (c = '$') Or (c = '@') Or (c = '[') Or (c = '\') Or (c = ']') Or (c = '^') Or (c = '`') Or (c = '{') Or (c = '|') Or (c = '}') Or (c = '~')
        ; encode char
        If (c = 9) Or (c = 32)            ; need only be encoded before/after CRLF
          If (PeekA(*b) = $0d) Or (PeekA(*b - 2) = $0a) Or encodews
            len + 3
          Else
            len + 1
          EndIf           
        Else
          If (c = 10) Or (c = 13)
            len + 1
          Else
            len + 3
          EndIf
        EndIf
      Else
        len + 1
      EndIf
      If len < linelen : cnt + 1 : Else : Break : EndIf
      *b + SizeOf(c)
      tl - 1
    Wend
  EndIf
  ProcedureReturn cnt
EndProcedure  
;}
;{ charset & encoding
;- charset & encoding
Procedure.i ____MSG_GetCharsetCode(charset.s) ;- incomplete
  Protected c.s, t.i
  
  c = UCase(charset)
  If c = "ISO-8859-15"
    t = #____MSG_CHARSET_ISO_8859_15
    
  Else
    t = #____MSG_CHARSET_UNKNOWN
  EndIf
  
  ProcedureReturn t
EndProcedure
Procedure.s ____MSG_GetCharsetName(charset.i) ;- incomplete
  Protected c.s
  
  Select charset
    Case #____MSG_CHARSET_ISO_8859_15
      c = "iso-8859-15"
    Default
      c = "unknown"
  EndSelect
  
  ProcedureReturn c
EndProcedure
Procedure.s ____MSG_GetHTMLCharset(html.s)
  Protected p.i, e.i, res.s
  
  res = ""
  p   = FindString(html, "charset", p)
  If p
    p = FindString(html, "=", p)
    If p
      e = FindString(html, ">", p + 2)
      If e
        res = ____SUP_TrimWSQ(Mid(html, p + 1, e - p - 1))
        e   = FindString(res, Chr(34), 1)
        If e
          res = ____SUP_TrimWSQ(Left(res, e - 1))
        EndIf
      EndIf
    EndIf
  EndIf
  ProcedureReturn res
EndProcedure  
Procedure.s ____MSG_GetSysCharset() ;- TODO
  ProcedureReturn "iso-8859-1"
EndProcedure
;}
;{ message allocating & freeing
;- message allocating & freeing
Procedure.i ____MSG_AllocMessage()                            ; Messagestruktur anfordern und initialisieren
  Protected *msg.____MSG_Message
  
  *msg = AllocateMemory(SizeOf(____MSG_Message))
  If *msg
    InitializeStructure(*msg, ____MSG_Message)
    *msg\bcc     = ""
    *msg\decoded = #False
  EndIf

  ProcedureReturn *msg
EndProcedure  
Procedure   ____MSG_ClearPart(*msg.____MSG_MimePart)          ; Messagestruktur (ein Part + seine subparts) bereinigen
  Protected bl.i
  
  If *msg
    ForEach *msg\Header()
      ForEach *msg\Header()\dat()
        *msg\Header()\dat()\key   = ""
        *msg\Header()\dat()\value = ""        
      Next
      ClearMap(*msg\Header()\dat())
    Next
    ClearMap(*msg\Header())   
    ForEach *msg\MimePart()     
      ____MSG_ClearPart(*msg\MimePart())
    Next
    ClearList(*msg\MimePart())
    If Not *msg\justptr 
      If *msg\body
        FreeMemory(*msg\body)
        *msg\body = #Null
      EndIf
    EndIf
    *msg\bodylen = 0    
  EndIf
EndProcedure
Procedure   ____MSG_ClearMessage(*msg.____MSG_Message)        ; Messagestruktur bereinigen, alle Parts; Struktur bleibt wiederverwertbar
  If *msg
    ____MSG_ClearPart(*msg)
    If(*msg\src) : FreeMemory(*msg\src) : *msg\src = #Null : EndIf
    *msg\bcc     = ""    
    *msg\decoded = #False
  EndIf
EndProcedure
Procedure   ____MSG_FreeMessage(*msg.____MSG_Message)         ; Messagestruktur freigeben; alle Parts
  If *msg
    ____MSG_ClearMessage(*msg)
    FreeMemory(*msg)
  EndIf
EndProcedure  
;}
;{ decoding functions
; smtliche Dekoder laufen auf ASCII-Basis, da eMails auf ASCII basieren; knnen aber Unicode-Strings handeln
Procedure.i ____MSG_DecodeBase64(*body, bodylen.i, *declen)                ; angepasster Base64 Dekoder; CRLF werden bersprungen; ASCII-Blockdekodierung
  Protected *unwrapped, unwrappedlen.i, linelen.i, a.i, *f, *t, *basedata, breaklen.i, linecount.i, lastlinelen.i, baselen.i
  Protected *bindata, binlen.i
  
  *bindata = #Null
  binlen   = 0
  *f       = *body                                
  *t       = *body + bodylen - 1
  For a = bodylen To 1 Step -1              ; Ende der Daten suchen; also alle WS am Ende rckwrts berspringen
    If PeekA(*t) >= 32 : Break : EndIf
    *t - 1
  Next a
  bodylen = a
  For a = 1 To bodylen                      ; Ende der ersten Zeile suchen
    If PeekA(*f) < 32 : Break : EndIf
    *f + 1
  Next a
  linelen = a - 1                            ; die Lnge einer Zeile ermitteln
  
  If bodylen > 0                ; wenn der Body daten enthlt
    If linelen = bodylen        ; Body besteht aus nur einer Zeile, also nichts weiter tun
      *unwrapped   = #Null
      *basedata    = *body
      baselen      = bodylen      
    Else                        ; Body hat mehr als eine Zeile
      *f = *body + linelen 
      For a = linelen + 1 To bodylen            ; lnge von zeilenumbruch und evtl einrckung ermitteln
        If PeekA(*f) >= 32 : Break : EndIf
        *f + 1
      Next a
      breaklen    = a - 1 - linelen                                 ; Lnge des Zeilenumbruches berechnen
      linecount   = Int(bodylen / (linelen + breaklen))             ; Zeilen anzahl berechnen
      lastlinelen = bodylen - ((linelen + breaklen) * linecount)    ; lnge der letzten Zeile berechnen
      *unwrapped  = AllocateMemory(bodylen)                         ; Speicher anfordern fr den Body
      If *unwrapped
        *basedata = *unwrapped
        *f        = *body
        *t        = *basedata
        For a = 1 To linecount       
          CopyMemory(*f, *t, linelen)          ; Zeile des codierten Bodys nehmen und anfgen
          *f + linelen + breaklen              ; Zeilenumbruch berspringen
          *t + linelen                         ; nchste Zeile
        Next a
        CopyMemory(*f, *t, lastlinelen)        ; letzte Zeile anhngen
        *t + lastlinelen
        baselen = *t - *basedata               ; neue Lnge ohne CRLF und Einrckungen
      EndIf
    EndIf
    If *basedata
      If baselen < 64 : baselen = 64 : EndIf  ; da Zielpuffer sonst zu klein wird
      *bindata = AllocateMemory(baselen)       ; Speicher zum decodieren anfordern
      If *bindata
        binlen = Base64Decoder(*basedata, baselen, *bindata, baselen)   ; Base64-Code dekodieren
      EndIf
    EndIf
    If *unwrapped
      FreeMemory(*unwrapped)
    EndIf
  EndIf
  
  PokeI(*declen, binlen)        ; dekodierte Lnge speichern und
  ProcedureReturn *bindata    ; adresse der dekodierten Daten zurckgeben
EndProcedure
Procedure.s ____MSG_DecodeBase64Str(*body, bodylen.i)                      ; angepasster Base64 Dekoder; CRLF werden bersprungen; ASCII-Stringdekodierung
  Protected res.i, declen.i, text.s
  
  text = ""
  res  = ____MSG_DecodeBase64(*body, bodylen, @declen)
  If declen > 0
    text = PeekS(res, declen, #PB_Ascii)
    FreeMemory(res)
  EndIf
  ProcedureReturn text
EndProcedure
Procedure.i ____MSG_DecodeQuotedPrintable(*body, bodylen.i, *declen)       ; angepasster QuotedPrintable Dekoder; CRLF werden bersprungen; ASCII-Blockdekodierung
  Protected *bindata, binlen.i, *f, *t, c.a, *bende, h.w, v.c
  Protected value.s, *value
  
  value    = "$00"
  *value   = @value + SizeOf(v)
  *bindata = AllocateMemory(bodylen)        ; Zieldatenpuffer, Gre ist auf jeden fall kleiner als die codierte Gre
  binlen   = 0
  If *bindata
    *f     = *body
    *t     = *bindata
    *bende = *body + bodylen - 1
    binlen = 0    
    While *f <= *bende                                    ; alle Zeichen durchgehen
      c  = PeekA(*f)
      *f + 1
      If c = 61 ; =                                       ; = gefunden -> ein Code
        h = PeekW(*f) : *f + 2                            ; gefolgt von zwei Bytes, die eine hexadezimale Zahl darstellen (z.b. =0A -> Chr(10) -> LF)
        If h <> $0a0d
          CompilerIf #PB_Compiler_Unicode
            PokeC(*value,              h & $00ff      )   ; value fllen
            PokeC(*value + SizeOf(v), (h & $ff00) >> 8)   ; -> value.s = "$0A" fr obiges beispiel
          CompilerElse
            PokeW(*value, h)                              ; im ASCII-Modus gehts direkt
          CompilerEndIf
          PokeA(*t, Val(value))                           ; Val macht aus derm Wert eine gltige Zahl zwischen $00 und $FF -> ASCII-Code, der wird angefgt
          *t + 1
        EndIf
      Else
        PokeA(*t, c)                                      ; war kein code, also zeichen direkt wieder anhngen
        *t + 1
      EndIf
    Wend
    binlen = *t - *bindata
  EndIf 
  
  PokeI(*declen, binlen)
  ProcedureReturn *bindata
EndProcedure
Procedure.s ____MSG_DecodeQuotedPrintableStr(*body, bodylen.i)             ; angepasster QuotedPrintable Dekoder; CRLF werden bersprungen; ASCII-Stringdekodierung
  Protected res.i, declen.i, text.s
  
  text = ""
  res  = ____MSG_DecodeQuotedPrintable(*body, bodylen, @declen)
  If declen > 0
    text = PeekS(res, declen, #PB_Ascii)
    FreeMemory(res)
  EndIf
  ProcedureReturn text
EndProcedure
Procedure.s ____MSG_DecodeInline(txt.s)                                    ; Decoder fr Inline-Encodierten ( =?charset?c?daten?= )
  Protected charset.s, codec.s, p1.i, p2.i, p3.i, p4.i, buf.s, blen.i, tmp.s
  
  ; wird nach jedem dekodierten block rekursiv aufgerufen, da mehr als ein block enthalten sein kann
  ; =?CHARSET?CODIERUNG?TEXT?=
  ; Codierung = B fr Base64 oder Q fr Quoted Printable
  If txt
    p1 = FindString(txt, "=?", 1)                           ; =? suchen          
    If p1                                                   ; gefunden, string enthlt kodierten bereich
      p2   = FindString(txt, "?", p1 + 2)                   ; ? suchen
      If p2                                                 ; gefunden
;       charset = Mid(txt, p1 + 1, p2 - p1 - 1)             ;- TODO Charset auslesen (wird aktuell noch nicht benutzt)
        p3      = FindString(txt, "?", p2 + 1)              ; ? suchen
        If p3                                               ; gefunden 
          codec = UCase(Mid(txt, p2 + 1, p3 - p2 - 1))      ; Codec auslesen
          p4    = FindString(txt, "?=", p3 + 1)             ; Ende des kodierten Textes suchen
          If p4                                             ; gefunden
            blen = p4 - p3 - 1                              ; Lnge des Textes
            If codec = "B"
              buf  = Space(blen)
              PokeS(@buf, Mid(txt, p3 + 1, blen), blen, #PB_Ascii)    ; Text als ASCII auslesen und dekodieren (Base64)
              ProcedureReturn ____MSG_DecodeBase64Str(@buf, blen) + ____MSG_DecodeInline(Mid(txt, p4 + 2))      ; dekodierten Text mit dem dekodierten Rest der Zeile zurckgeben
            ElseIf codec = "Q"              
              buf  = Space(blen)
              PokeS(@buf, ReplaceString(Mid(txt, p3 + 1, blen), "_", " "), blen, #PB_Ascii)   ; Text als ASCII auslesen und dekodieren (QuotedPrintable)
              ProcedureReturn  ____MSG_DecodeQuotedPrintableStr(@buf, blen) + ____MSG_DecodeInline(Mid(txt, p4 + 2))    ; dekodierten Text mit dem dekodierten Rest der Zeile zurckgeben
            Else
              ProcedureReturn Mid(txt, p3 + 1, blen) + ____MSG_DecodeInline(Mid(txt, p4 + 2))    ; unbekannter codec, Text mit dem dekodierten Rest der Zeile zurckgeben
            EndIf
          EndIf
        EndIf
      EndIf
    EndIf
  EndIf
  
  ProcedureReturn txt
EndProcedure
;}
;{ message analyzing
;- message analyzing
Procedure.b ____MSG_SingleDataExpected(hdrname.s)         ; Header testen, ob mehrere Daten (mit ; getrennte key=value-Paare) erwartet werden (#False) oder nicht (#True)
  ;- probably incomplete
  If hdrname = "CONTENT-TYPE"
    ProcedureReturn #False
  ElseIf hdrname = "CONTENT-DISPOSITION"
    ProcedureReturn #False
    
  EndIf
  ProcedureReturn #True
EndProcedure
Procedure.b ____MSG_AnalyzeMimePart(*msg.____MSG_MimePart, *src, maxlen.i)    ; Message-Sub-Part zerlegen
  Protected *start, *p, *ende, *lstart, *lende, *dstart, *dende, *d, *ep, *dstart2, *bodystart, *bodyend, *boundary, *bstart, *bende, *safe
  Protected len.i, c.a, pos.i, llen.i, tmp.i, blen.i
  Protected hdrname.s, hdrdatal.s, hdrdatar.s, boundary.s, test.c, firstbound.b, lastbound.b, res.b, t.l, *m.____MSG_Header, uhdrname.s, uhdrdatal.s
  
  ; Header ermitteln
  ; -> CRLFCRLF suchen (Leerzeile)
  res      = #False
  *start   = *src                                      ; *start == start des headers
  len      = -1
  *bodyend = *src + maxlen - 1
  *ende    = #Null
  For pos = 1 To maxlen
    If PeekL(*src) = $0a0d0a0d
      len   = *src - *start + 2                       ; len    == lnge des headers (inkl. einem CRLF)
      *ende = *src + 1                                ; *ende  == letztes Zeichen des headers
      *src  + 4                                       ; *src   == start des nchsten Blockes nach der Leerzeile
      Break     
    EndIf
    *src + 1
  Next pos
  *bodystart = *src
  
  ; Header parsen
  *lstart = *start                                    ; *lstart == anfang der zeile
  For *p = *start To *ende
    If PeekW(*p) = $0a0d
      *p + 2                                          ; *p      == start der nchsten zeile
      c = PeekA(*p)
      If (c <> 9) And (c <> 32)                       ; KEIN zeilenumbruch
        *lende = *p - 1                               ; *lende  == letztes zeichen der zeile
        llen   = *lende - *lstart + 1                 ; llen    == lnge der zeile
        For *dstart = *lstart To *lende
          If PeekA(*dstart) = Asc(":")
            *dstart + 1
            Break
          EndIf
        Next *dstart
        hdrname  = ____SUP_TrimWS(PeekS(*lstart, *dstart - *lstart - 1, #PB_Ascii))
        uhdrname = UCase(hdrname)
        *dstart + 1
        With *msg\header(uhdrname)
          If ____MSG_SingleDataExpected(uhdrname)             ; keine unterteilung
            hdrdatar             = ____SUP_TrimWS(PeekS(*dstart, *lende - *dstart, #PB_Ascii))
            \dat(uhdrname)\key   = hdrname
            \dat(uhdrname)\value = hdrdatar
          Else                                          ; parameter sammeln
            *ep      = #Null
            *dstart2 = *dstart
            For *d = *dstart To *lende 
              c = PeekA(*d)
              If c = 34
                Repeat : *d + 1 : Until PeekA(*d) = 34
              ElseIf (c = Asc("=")) And (*ep = #Null)
                *ep = *d
              ElseIf (c = Asc(";")) Or ((c = $0d) And ((*ep <> #Null) Or (*d = *lende - 1)))
                If *ep                                ; = gefunden
                  hdrdatal              = ____SUP_TrimWS(PeekS(*dstart2, *ep - *dstart2, #PB_Ascii))
                  uhdrdatal             = UCase(hdrdatal)
                  hdrdatar              = ____SUP_TrimWSQ(PeekS(*ep + 1, *d - *ep - 1, #PB_Ascii))
                  *ep                   = #Null
                  \dat(uhdrdatal)\key   = hdrdatal
                  \dat(uhdrdatal)\value = hdrdatar
                Else
                  hdrdatar              = ____SUP_TrimWSQ(PeekS(*dstart, *d - *dstart2, #PB_Ascii))
                  \dat(uhdrname)\key    = hdrname
                  \dat(uhdrname)\value  = hdrdatar
                EndIf
                *d       + 1 
                *dstart2 = *d
              EndIf
            Next *d
          EndIf
        EndWith
        *lstart = *p                                  ; *lstart == anfang der nchsten zeile
      EndIf       
    EndIf
  Next *p
  
  ____MSG_GetHeaderValue(boundary, *msg, "CONTENT-TYPE", "BOUNDARY")
    
  If boundary ; erste boundary suchen
    blen       = Len(boundary)
    *boundary  = AllocateMemory(blen + 1)
    If *boundary = #Null : ProcedureReturn #False : EndIf
    PokeS(*boundary, boundary, blen, #PB_Ascii)   
    *bstart = *bodystart
    For *d = *bodystart To *bodyend
      If PeekW(*d) = $2d2d
        *bende = *d - 1
        If CompareMemoryString(*d + 2, *boundary, 0, blen, #PB_Ascii) = #PB_String_Equal
          *safe  = *d
          *d     + 2 
          *d     + blen
          If PeekW(*d) = $2d2d        ; das war die letzte boundary
            If PeekW(*d + 2) = $0a0d  ; und der zeilenumbruch danach; wenn nicht, kann es nicht die boundary sein
              *msg\body    = *bstart
              *msg\bodylen = *bende - *bstart + 2
              *msg\justptr = #True
              *bstart      = *d + 4
              res          = #True
              Break
            Else
              *d = *safe
            EndIf
          ElseIf PeekW(*d) = $0a0d    ; normaler Zeilenumbruch; wenn nicht, kann es nicht die boundary sein
            *msg\body    = *bstart
            *msg\bodylen = *bende - *bstart + 2             
            *msg\justptr = #True
            *bstart      = *d + 2
            res          = #True
            Break
          Else
            *d = *safe
          EndIf
        EndIf
      EndIf
    Next *d
    *bodystart = *bstart  ; *bodystart == erstes zeichen nach der boundary
    
    For *d = *bodystart To *bodyend
      If PeekW(*d) = $2d2d
        *bende = *d - 1
        If CompareMemoryString(*d + 2, *boundary, 0, blen, #PB_Ascii) = #PB_String_Equal
          *safe  = *d
          *d     + 2 
          *d     + blen
          If PeekW(*d) = $2d2d        ; das war die letzte boundary
            If PeekW(*d + 2) = $0a0d  ; und der zeilenumbruch danach; wenn nicht, kann es nicht die boundary sein
              AddElement(*msg\MimePart())
              res = ____MSG_AnalyzeMimePart(@*msg\MimePart(), *bstart, *bende - *bstart + 2)              
              *bstart      = *d + 4
            Else
              *d = *safe
            EndIf
          ElseIf PeekW(*d) = $0a0d    ; normaler Zeilenumbruch; wenn nicht, kann es nicht die boundary sein
            AddElement(*msg\MimePart())
            res = ____MSG_AnalyzeMimePart(@*msg\MimePart(), *bstart, *bende - *bstart + 2)              
            *bstart = *d + 2
          Else
            *d = *safe
          EndIf
        EndIf
      EndIf
    Next *d
  Else
    ; keine boundary, rest als body speichern
    *msg\body    = *bodystart
    *msg\bodylen = *bodyend - *bodystart - 2  
    *msg\justptr = #True
  EndIf
  
  ProcedureReturn #True
EndProcedure
Procedure.b ____MSG_AnalyzeMessage(*msg.____MSG_Message)                      ; Message zerlegen
  If *msg = #Null : ProcedureReturn #False : EndIf
  
  *msg\decoded = ____MSG_AnalyzeMimePart(*msg, *msg\src, MemorySize(*msg\src))
  
  ProcedureReturn *msg\decoded
EndProcedure
Procedure   ____MSG_BuildAttachmentList(*part.____MSG_MimePart, List AttPartList.i())     ; eine Liste aller speicherbaren Attachments erstellen (Inline-Sachen wie z.B. bilder in gmx-werbungen werden hier nicht eingefgt)
  Protected cd.s
  
  If *part
    ____MSG_GetHeaderData(cd, *part, "CONTENT-DISPOSITION")
  
    If UCase(cd) = "ATTACHMENT" 
      AddElement(AttPartList())
      AttPartList() = *part
    EndIf
    ForEach *part\MimePart()
      ____MSG_BuildAttachmentList(*part\MimePart(), AttPartList())
    Next
  EndIf
EndProcedure
;}
;{ message loading / saving
;- message loading / saving
Procedure.i ____MSG_SetMailSourceBin(*src, srclen.i, *msg.____MSG_Message = #Null)     ; Mailquellcode setzen; es wird ein Binrer ASCII-String bergeben
  Protected reuse.b
  
  If *msg
    ____MSG_ClearMessage(*msg)
    reuse = #True
  Else
    reuse = #False  
  EndIf
  If *src And srclen
    If Not *msg : *msg = ____MSG_AllocMessage() : EndIf
    If *msg
      *msg\decoded = #False
      *msg\src     = AllocateMemory(srclen + 1)
      If *msg\src
        CopyMemory(*src, *msg\src, srclen)
        PokeA(*msg\src + srclen, 0)
        ProcedureReturn *msg
      EndIf
      If Not reuse : FreeMemory(*msg) : *msg = #Null : EndIf
    EndIf
  EndIf
  ProcedureReturn *msg
EndProcedure
Procedure.i ____MSG_SetMailSource(src.s, *msg.____MSG_Message = #Null)                 ; Mailquellcode setzen; es wird ein String bergeben
  Protected reuse.b, l.i
  
  If *msg
    ____MSG_ClearMessage(*msg)
    reuse = #True
  Else
    reuse = #False  
  EndIf
  If src 
    l = Len(src)    
    If Not *msg : *msg = ____MSG_AllocMessage() : EndIf
    If *msg
      *msg\decoded = #False
      *msg\src     = AllocateMemory(l + 1)
      If *msg\src
        PokeS(*msg\src, src, l, #PB_Ascii)
        ProcedureReturn *msg
      EndIf
      If Not reuse : FreeMemory(*msg) : *msg = #Null : EndIf
    EndIf
  EndIf
  ProcedureReturn *msg
EndProcedure
Procedure.s ____MSG_GetMailSource(*msg.____MSG_Message)                                ; Mailquellcode zurckgeben. es wird ein String zurckgegeben
  If *msg
    If *msg\src
      ProcedureReturn PeekS(*msg\src, MemorySize(*msg\src), #PB_Ascii)
    EndIf
  EndIf
  ProcedureReturn ""
EndProcedure
Procedure.i ____MSG_LoadRAWMail(filename.s, *msg.____MSG_Message = #Null)              ; eine Mail im Plain-Text-Format lesen (EML); OHNE bcc daten
  Protected reuse.b, file.i, length.i, bytes.i, ok.b
  
  ok = #False
  If *msg
    ____MSG_ClearMessage(*msg)
    reuse = #True
  Else
    reuse = #False  
  EndIf
  If filename
    If Not *msg : *msg = ____MSG_AllocMessage() : EndIf
    If *msg
      *msg\decoded = #False
      file         = ReadFile(#PB_Any, filename)
      If IsFile(file)
        length = Lof(file)
        If length > 0
          *msg\src = AllocateMemory(length + 1)
          If *msg\src
            bytes = ReadData(file, *msg\src, length)
            If bytes = length
              PokeA(*msg\src + length, 0)
              ok = #True
            EndIf
          EndIf
        EndIf
        CloseFile(file)
      EndIf   
      If Not ok
        If *msg\src   : FreeMemory(*msg\src)  : *msg\src = #Null  : EndIf
        If Not reuse  : FreeMemory(*msg)      : *msg = #Null      : EndIf
      EndIf
    EndIf
  EndIf
  ProcedureReturn *msg  
EndProcedure
Procedure.b ____MSG_SaveRAWMail(*msg.____MSG_Message, filename.s)                      ; eine Mail im Plain-Text-Format screiben (EML); OHNE bcc daten
  Protected file.i, ok.b
  
  ok = #False
  If *msg
    If *msg\src
      file = CreateFile(#PB_Any, filename)
      If IsFile(file)
        WriteData(file, *msg\src, MemorySize(*msg\src) - 1)   ; im Memorysize ist das abschlieende Chr(0) drin, das weglasen
        CloseFile(file)
        ok = #True
      EndIf
    EndIf
  EndIf
  
  ProcedureReturn ok
EndProcedure
Procedure.b ____MSG_SaveMessage(*msg.____MSG_Message, Filename.s, complevel.i = 9)     ; eine Mail im binren format speichern (komprimiert); MIT bcc daten
  Protected fid.i
  
  fid = ____FILE_CreateFile(FileName, "AWML")
  If IsFile(fid)      
    ____FILE_WriteStringHdr(fid, "BCC ", *msg\bcc, #PB_Ascii)                      ; BCC + Data (if available)
    ____FILE_WriteHeader(fid, "SRC ")                                              ; Message Source Header
    ____FILE_WriteBlock(fid, *msg\src, MemorySize(*msg\src), #True, complevel)     ; Message Source Data
    ____FILE_FinishFile(fid)

    ProcedureReturn #True
  EndIf

  ProcedureReturn #False 
EndProcedure
Procedure.i ____MSG_LoadMessage(filename.s, *msg.____MSG_Message = #Null)              ; eine Mail im binren format laden; MIT bcc daten
  Protected reuse.b, fid.i, length.i, bytes.i, ok.b, hdr.s, slen.l, flags.b
  
  ok = #False
  If *msg
    ____MSG_ClearMessage(*msg)
    reuse = #True
  Else
    reuse = #False  
  EndIf
  If filename
    If Not *msg : *msg = ____MSG_AllocMessage() : EndIf
    If *msg
      *msg\decoded = #False
      fid          = ____FILE_ReadFile(FileName, "AWML")
      If IsFile(fid)
        ok = #True
        While Not Eof(fid)
          hdr = ____FILE_ReadHeader(fid)
          If hdr = "SRC "
            If Not *msg\src
              *msg\src = ____FILE_ReadBlock(fid, @slen, @flags)
            Else
              ok = #False 
            EndIf
          ElseIf hdr = "BCC "
            *msg\bcc = ____FILE_ReadString(fid)
          ElseIf hdr = "EOF."
            ; End Of File
            Break
          Else
            ____FILE_SkipBlock(fid)
          EndIf
        Wend
        ____FILE_CloseFile(fid)
      EndIf

      If Not ok
        If *msg\src   : FreeMemory(*msg\src)  : *msg\src = #Null  : EndIf
        If Not reuse  : FreeMemory(*msg)      : *msg     = #Null  : EndIf
      EndIf
    EndIf
  EndIf
  ProcedureReturn *msg  
EndProcedure
;}
;{ get message data
;- get message data
; den entsprechenden Header auslesen und zurckgeben
Procedure.s ____MSG_GetContentType(*msg.____MSG_MimePart)
  Protected res.s
  
  If *msg
    ____MSG_GetHeaderData(res, *msg, "CONTENT-TYPE")
    If res
      ProcedureReturn StringField(res, 1, "/")
    EndIf
  EndIf
  ProcedureReturn ""
EndProcedure
Procedure.s ____MSG_GetContentSubType(*msg.____MSG_MimePart)
  Protected res.s
  
  If *msg
    ____MSG_GetHeaderData(res, *msg, "CONTENT-TYPE")
    If res
      ProcedureReturn StringField(res, 2, "/")
    EndIf
  EndIf
  ProcedureReturn ""
EndProcedure
Procedure.s ____MSG_GetCharset(*msg.____MSG_MimePart)
  Protected res.s
  
  If *msg
    ____MSG_GetHeaderValue(res, *msg, "CONTENT-TYPE", "CHARSET")    
  EndIf
  ProcedureReturn res
EndProcedure
Procedure.s ____MSG_GetEncoding(*msg.____MSG_MimePart)
  Protected res.s
  
  If *msg
    ____MSG_GetHeaderData(res, *msg, "CONTENT-TRANSFER-ENCODING")
  EndIf
  ProcedureReturn res
EndProcedure
Procedure.s ____MSG_GetBoundary(*msg.____MSG_MimePart)
  Protected res.s
  
  If *msg
    ____MSG_GetHeaderValue(res, *msg, "CONTENT-TYPE", "BOUNDARY")
  EndIf
  ProcedureReturn res
EndProcedure
Procedure.s ____MSG_GetContentDisposition(*msg.____MSG_MimePart)
  Protected res.s
  
  If *msg
    ____MSG_GetHeaderData(res, *msg, "CONTENT-DISPOSITION")
  EndIf
  ProcedureReturn res
EndProcedure
Procedure.s ____MSG_GetContentName(*msg.____MSG_MimePart)
  Protected res.s
  
  If *msg
    ____MSG_GetHeaderValue(res, *msg, "CONTENT-TYPE", "NAME")
  EndIf
  ProcedureReturn res
EndProcedure
Procedure.s ____MSG_GetContentFilename(*msg.____MSG_MimePart)
  Protected res.s
  
  If *msg
    ____MSG_GetHeaderValue(res, *msg, "CONTENT-DISPOSITION", "FILENAME")
  EndIf
  ProcedureReturn res
EndProcedure
Procedure.s ____MSG_GetContentID(*msg.____MSG_MimePart)
  Protected res.s
  
  If *msg
    ____MSG_GetHeaderData(res, *msg, "CONTENT-ID")
  EndIf
  ProcedureReturn res
EndProcedure
Procedure.i ____MSG_FindPartCID(*msg.____MSG_MimePart, cid.s, cs.b)
  Protected res.i
  
  If *msg
    If cs  
      If ____MSG_GetContentID(*msg) = cid
        ProcedureReturn *msg
      EndIf
    Else
      If UCase(____MSG_GetContentID(*msg)) = UCase(cid)
        ProcedureReturn *msg
      EndIf
    EndIf      
    If UCase(____MSG_GetContentType(*msg)) = "MULTIPART"
      ForEach *msg\MimePart()
        res = ____MSG_FindPartCID(*msg\MimePart(), cid, cs)
        If res : ProcedureReturn res : EndIf
      Next
    EndIf
  EndIf
  
  ProcedureReturn #Null
EndProcedure
Procedure.i ____MSG_FindPartName(*msg.____MSG_MimePart, name.s, cs.b)
  Protected res.i
  
  If *msg
    If cs
      If ____MSG_GetContentName(*msg) = name
        ProcedureReturn *msg
      EndIf
    Else
      If UCase(____MSG_GetContentName(*msg)) = UCase(name)
        ProcedureReturn *msg
      EndIf
    EndIf      
    If UCase(____MSG_GetContentType(*msg)) = "MULTIPART"
      ForEach *msg\MimePart()
        res = ____MSG_FindPartName(*msg\MimePart(), name, cs)
        If res : ProcedureReturn res : EndIf
      Next
    EndIf
  EndIf
  
  ProcedureReturn #Null
EndProcedure
Procedure.i ____MSG_FindPartFileName(*msg.____MSG_MimePart, filename.s, cs.b)
  Protected res.i, fn.s
  
  If *msg
    If cs
      If ____MSG_GetContentFilename(*msg) = filename
        ProcedureReturn *msg
      EndIf
    Else
      If UCase(____MSG_GetContentFilename(*msg)) = UCase(filename)
        ProcedureReturn *msg
      EndIf
    EndIf
    If UCase(____MSG_GetContentType(*msg)) = "MULTIPART"
      ForEach *msg\MimePart()
        res = ____MSG_FindPartFileName(*msg\MimePart(), filename, cs)
        If res : ProcedureReturn res : EndIf
      Next
    EndIf
  EndIf
  
  ProcedureReturn #Null
EndProcedure
Procedure.s ____MSG_GetSubject(*msg.____MSG_MimePart)
  Protected res.s
  
  If *msg
    ____MSG_GetHeaderData(res, *msg, "SUBJECT")
    res = ____MSG_DecodeInline(res)
  EndIf
  ProcedureReturn res
EndProcedure
Procedure.s ____MSG_GetFrom(*msg.____MSG_MimePart)
  Protected res.s
  
  If *msg
    ____MSG_GetHeaderData(res, *msg, "FROM")
    res = ____MSG_DecodeInline(res)
  EndIf
  ProcedureReturn res
EndProcedure
Procedure.s ____MSG_GetCC(*msg.____MSG_MimePart)
  Protected res.s
  
  If *msg
    ____MSG_GetHeaderData(res, *msg, "CC")
    res = ____MSG_DecodeInline(res)
  EndIf
  ProcedureReturn res
EndProcedure
Procedure.s ____MSG_GetCCMails(*msg.____MSG_MimePart)
  Protected res.s
  
  If *msg
    ____MSG_GetHeaderData(res, *msg, "CC")
    res = ____MSG_CreateMailAdrList(____MSG_DecodeInline(res), ", ")
  EndIf
  ProcedureReturn res
EndProcedure
Procedure.s ____MSG_GetBCC(*msg.____MSG_Message)
  If *msg
    ProcedureReturn *msg\bcc
  EndIf
  ProcedureReturn ""
EndProcedure
Procedure.s ____MSG_GetBCCMails(*msg.____MSG_Message)
  If *msg
    ProcedureReturn ____MSG_CreateMailAdrList(*msg\bcc, ", ")
  EndIf
  ProcedureReturn ""
EndProcedure
Procedure.s ____MSG_GetTo(*msg.____MSG_MimePart)
  Protected res.s
  
  If *msg
    ____MSG_GetHeaderData(res, *msg, "TO")
    res = ____MSG_DecodeInline(res)
  EndIf
  ProcedureReturn res
EndProcedure
Procedure.s ____MSG_GetToMails(*msg.____MSG_MimePart)
  Protected res.s
  
  If *msg
    ____MSG_GetHeaderData(res, *msg, "TO")
    res = ____MSG_CreateMailAdrList(____MSG_DecodeInline(res), ", ")
  EndIf
  ProcedureReturn res
EndProcedure
Procedure.s ____MSG_GetReturnPath(*msg.____MSG_MimePart)
  Protected res.s
  
  If *msg
    ____MSG_GetHeaderData(res, *msg, "RETURN-PATH")
    res = ____MSG_DecodeInline(res)
  EndIf
  ProcedureReturn res
EndProcedure
Procedure.s ____MSG_GetMessageID(*msg.____MSG_MimePart)
  Protected res.s
  
  If *msg
    ____MSG_GetHeaderData(res, *msg, "MESSAGE-ID")
  EndIf
  ProcedureReturn res
EndProcedure
Procedure.s ____MSG_GetDateStr(*msg.____MSG_MimePart)
  Protected res.s
  
  If *msg
    ____MSG_GetHeaderData(res, *msg, "DATE")
  EndIf
  ProcedureReturn res
EndProcedure
Procedure.i ____MSG_GetDate(*msg.____MSG_MimePart)
  Protected res.s
  
  res = ____MSG_GetDateStr(*msg)
  If res
    ProcedureReturn ____DATE_ParseRFC2822DateTime(res)
  EndIf
  
  ProcedureReturn 0
EndProcedure
Procedure.i ____MSG_GetXPriority(*msg.____MSG_MimePart)
  Protected res.s, prio.i
  
  prio = #____MSG_PRIORITY_NORMAL
  ____MSG_GetHeaderData(res, *msg, "X-PRIORITY")
  If res
    prio = Val(____SUP_TrimWS(res))
  EndIf
  
  ProcedureReturn prio
EndProcedure
Procedure.s ____MSG_GetDispositionNotificationTo(*msg.____MSG_MimePart)
  Protected res.s
  
  If *msg
    ____MSG_GetHeaderData(res, *msg, "DISPOSITION-NOTIFICATION-TO")
    res = ____MSG_DecodeInline(res)
  EndIf
  ProcedureReturn res
EndProcedure
Procedure.s ____MSG_GetReplyTo(*msg.____MSG_MimePart)
  Protected res.s
  
  If *msg
    ____MSG_GetHeaderData(res, *msg, "REPLY-TO")
    res = ____MSG_DecodeInline(res)
  EndIf
  ProcedureReturn res
EndProcedure
; Body-Daten abrufen
Procedure.i ____MSG_GetHTMLPart(*msg.____MSG_Message)                     ; den text/html-Part suchen und zurckgeben
  Protected res.i
  
  If *msg
    If UCase(____MSG_GetContentType(*msg)) = "TEXT"
      If UCase(____MSG_GetContentSubType(*msg)) = "HTML"
        ProcedureReturn *msg
      EndIf
    ElseIf UCase(____MSG_GetContentType(*msg)) = "MULTIPART"
      ForEach *msg\MimePart()
        res = ____MSG_GetHTMLPart(*msg\MimePart())
        If res : ProcedureReturn res : EndIf
      Next
    EndIf
  EndIf
  
  ProcedureReturn #Null
EndProcedure
Procedure.i ____MSG_GetPlainPart(*msg.____MSG_Message)                    ; den text/plain-Part suchen und zurckgeben
  Protected res.i
  If *msg
    If UCase(____MSG_GetContentType(*msg)) = "TEXT"
      If UCase(____MSG_GetContentSubType(*msg)) = "PLAIN"
        ProcedureReturn *msg
      EndIf
    ElseIf UCase(____MSG_GetContentType(*msg)) = "MULTIPART"
      ForEach *msg\MimePart()
        res = ____MSG_GetPlainPart(*msg\MimePart())
        If res : ProcedureReturn res : EndIf
      Next
    EndIf
  EndIf
  
  ProcedureReturn #Null
EndProcedure
Procedure.s ____MSG_GetHTML(*msg.____MSG_Message)                         ; den text/html-Part suchen und den Body als String zurckgeben
  Protected *part.____MSG_MimePart
  
  If *msg
    *part = ____MSG_GetHTMLPart(*msg)
    If *part
      If UCase(____MSG_GetEncoding(*part)) = "QUOTED-PRINTABLE"
        ProcedureReturn ____MSG_DecodeQuotedPrintableStr(*part\body, *part\bodylen)
      ElseIf UCase(____MSG_GetEncoding(*part)) = "BASE64"
        ProcedureReturn ____MSG_DecodeBase64Str(*part\body, *part\bodylen)
      Else
        ProcedureReturn PeekS(*part\body, *part\bodylen, #PB_Ascii)
      EndIf
    EndIf
  EndIf
  
  ProcedureReturn ""
EndProcedure
Procedure.s ____MSG_GetPlainText(*msg.____MSG_Message)                    ; den text/plain-Part suchen und den Body als String zurckgeben
  Protected *part.____MSG_MimePart
  
  If *msg
    *part = ____MSG_GetPlainPart(*msg)
    If *part
      If UCase(____MSG_GetEncoding(*part)) = "QUOTED-PRINTABLE"
        ProcedureReturn ____MSG_DecodeQuotedPrintableStr(*part\body, *part\bodylen)
      ElseIf UCase(____MSG_GetEncoding(*part)) = "BASE64"
        ProcedureReturn ____MSG_DecodeBase64Str(*part\body, *part\bodylen)
      Else
        ProcedureReturn PeekS(*part\body, *part\bodylen, #PB_Ascii)
      EndIf
    EndIf
  EndIf
  
  ProcedureReturn ""
EndProcedure
Procedure.s ____MSG_GetPlainAsHTML(*msg.____MSG_Message)                  ; den text/plain-Part suchen und den Body als in HTML umgewandelten String zurckgeben
  Protected plain.s, html.s
  Protected *part.____MSG_MimePart
  
  html  = ""
  If *msg
    *part = ____MSG_GetPlainPart(*msg)
    If *part
      plain = ____MSG_GetPlainText(*part)
      If plain
        html = "<!DOCTYPE html PUBLIC "+Chr(34)+"-//W3C//DTD html 4.01 Transitional//EN"+Chr(34)+">"+Chr(10)
        html + "<html><head><meta content="+Chr(34)+"text/html; charset="+____MSG_GetCharset(*part)+Chr(34)+" http-equiv="+Chr(34)+"content-type"+Chr(34)+">"
        html + "<title></title></head><body><pre><code>"
        html + plain
        html + "</code></pre></body></html>"
      EndIf
    EndIf
  EndIf
  
  ProcedureReturn html
EndProcedure
Procedure.s ____MSG_GetPartAsString(*part.____MSG_MimePart)               ; den Body des bergebenen Parts auslesen (ggf dekodieren) und als String zurckgeben
  If *part
    If UCase(____MSG_GetEncoding(*part)) = "QUOTED-PRINTABLE"
      ProcedureReturn ____MSG_DecodeQuotedPrintableStr(*part\body, *part\bodylen)
    ElseIf UCase(____MSG_GetEncoding(*part)) = "BASE64"
      ProcedureReturn ____MSG_DecodeBase64Str(*part\body, *part\bodylen)
    Else
      ProcedureReturn PeekS(*part\body, *part\bodylen, #PB_Ascii)
    EndIf
  EndIf
  ProcedureReturn ""
EndProcedure
Procedure.i ____MSG_GetPartAsBin(*part.____MSG_MimePart, *partlen)        ; den Body des bergebenen Parts auslesen (ggf dekodieren) und als Zeiger auf Speicheradresse zurckgeben; die Lnge wird in PartLen gespeichert
  Protected *res, len.i
  
  *res = #Null  
  If *part
    If UCase(____MSG_GetEncoding(*part)) = "QUOTED-PRINTABLE"
      *res = ____MSG_DecodeQuotedPrintable(*part\body, *part\bodylen, @len)
    ElseIf UCase(____MSG_GetEncoding(*part)) = "BASE64"
      *res = ____MSG_DecodeBase64(*part\body, *part\bodylen, @len)
    Else
      len  = *part\bodylen
      *res = AllocateMemory(len)
      If *res : CopyMemory(*part\body, *res, len) : EndIf
    EndIf
  EndIf
  If *res
    PokeI(*partlen, len)
  Else
    PokeI(*partlen, 0)
  EndIf
  
  ProcedureReturn *res
EndProcedure
Procedure.b ____MSG_SavePartToFile(*part.____MSG_MimePart, filename.s)    ; den Body des bergebenen Parts in die angegebene Date (inkl, Pfad) speichern (ggf vorher dekodieren)
  Protected *bin, len.i, res.b, file.i
  
  If filename And *part
    res  = #False
    *bin = ____MSG_GetPartAsBin(*part, @len)
    If *bin
      file = CreateFile(#PB_Any, filename)
      If IsFile(file)
        WriteData(file, *bin, len)
        CloseFile(file)
        res = #True
      EndIf
      FreeMemory(*bin)  
    EndIf
  EndIf
  ProcedureReturn res
EndProcedure
;}
;{ encoding functions
;- encoding functions
Procedure.i ____MSG_EncodeBase64(*bin, binlen.i, *enclen, linelen.i = 76)             ; Base 64 Encoder, der auch Zeilenumbrche einfgt
  Protected *encbin, *basebin, newlen.i, maxlen.i, lines.i, *a, *b, i.i, lll.i
  
  *encbin = #Null
  newlen  = 0
  If *bin And binlen
    newlen   = Int((binlen * 140) / 100) + 100 ; base64 wird ca 33% grer
    *basebin = AllocateMemory(newlen)
    If *basebin
      maxlen = Base64Encoder(*bin, binlen, *basebin, newlen)      ; Daten base64-kodieren
      If maxlen
        ; *basebin == codierter string
        ; maxlen   == codierte lnge
        If linelen = #PB_Any    ; kein zeilenumbruch
          lines   = 1           ; also nur eine zeile
          lll     = 0           ; lll = LastLineLength, die Lnge der letzten Zeile, ist hier 0
          newlen  = maxlen + 2  ; lnge inkl letztem CRLF
          linelen = maxlen
        Else  ; Standardlnge ist max 80 zeichen inkl. CRLF; hier ist es als max. 76 Zeichen + CRLF definiert
          lines   = Int(maxlen / linelen)                            ; Zeilenanzahl berechnen
          lll     = maxlen % linelen : If lll : lines + 1 : EndIf   ; Anzahl an Zeilen (letzte u.U. nicht volle Lnge) -> lll = LastLineLength
          newlen  = maxlen + (lines * 2)                             ; lnge mit zeilenumbrchen
        EndIf
        *encbin = AllocateMemory(newlen)
        If *encbin
          *a = *encbin
          *b = *basebin
          For i = 2 To lines                                                      ; kodierten Block zerlegen
            CopyMemory(*b, *a, linelen)         : *a + linelen : *b + linelen     ; Zeile anhngen
            PokeW(*a, $0a0d)                    : *a + 2                          ; CRLF anhngen
          Next i
          If lll                                ; keine komplette Zeile           ; da schleife rechnerisch erst ab zeile 2 luft:
            CopyMemory(*b, *a, lll)             : *a + lll                        ; "echte" letzte zeile
          Else                                  ; eine komplette Zeile
            CopyMemory(*b, *a, linelen)         : *a + linelen                    ; da keine letzte (unvollstndige) zeile existiert ist noch eine komplette brig
          EndIf
          PokeW(*a, $0a0d)                      : *a + 2                          ; letztes CRLF anhngen
        EndIf
      EndIf
      maxlen = *a - *encbin                 ; "echte" kodierte Gre berechnen
      FreeMemory(*basebin)
    EndIf
  EndIf
  If *encbin
    PokeI(*enclen, maxlen)
  Else
    PokeI(*enclen, 0) 
  EndIf
  ProcedureReturn *encbin
EndProcedure
Procedure.s ____MSG_EncodeBase64BinToStr(*bin, binlen.i, linelen.i = 76)              ; Base 64 Encoder, der auch Zeilenumbrche einfgt (Stringrckgabe)
  Protected elen.i, res.s, *enc
  
  res  = ""
  *enc = ____MSG_EncodeBase64(*bin, binlen, @elen, linelen)
  If *enc
    res = PeekS(*enc, elen, #PB_Ascii)
    FreeMemory(*enc)  
  EndIf
  
  ProcedureReturn res   
EndProcedure
Procedure.i ____MSG_EncodeBase64Str(text.s, len.i, *enclen, linelen.i = 76)           ; Base 64 Encoder, der auch Zeilenumbrche einfgt
  Protected *res, tlen.i, *bin
  
  *res = #Null
  If text And len
    CompilerIf #PB_Compiler_Unicode
      *bin = AllocateMemory(len + 2)
      If *bin
        PokeS(*bin, text, len, #PB_Ascii)
        *res = ____MSG_EncodeBase64(*bin, len, @tlen, linelen)
        FreeMemory(*bin)
      EndIf
    CompilerElse
      *res = ____MSG_EncodeBase64(@text, len, @tlen, linelen)
    CompilerEndIf
  EndIf
  If *res
    PokeI(*enclen, tlen)
  Else
    PokeI(*enclen, 0)
  EndIf
  
  ProcedureReturn *res
EndProcedure
Procedure.s ____MSG_EncodeBase64StrToStr(text.s)                                      ; Base 64 String Encoder (Stringrckgabe)
  Protected *res, elen.i, res.s
  
  res = ""
  If text
    *res = ____MSG_EncodeBase64Str(text, Len(text), @elen, #PB_Any)
    If *res
      res = PeekS(*res, elen, #PB_Ascii)
      FreeMemory(*res)  
    EndIf
  EndIf
  
  ProcedureReturn res
EndProcedure
Procedure.i ____MSG_EncodeQuotedPrintable(*bin, binlen.i, *enclen, linelen.i = 75, encodews.b = #False)      ; QuotedPrintable Encoder, der auch Zeilenumbrche einfgt
  Protected *encbin, newlen, *a, *b, i.i, c.c, lines.i, lll.i, maxlen.i, llen.i
  Protected Dim hx.a(15)
  
  For i = 0 To 9 : hx(i)      = '0' + i : Next i
  For i = 0 To 5 : hx(i + 10) = 'A' + i : Next i 
    
  *encbin = #Null
  maxlen  = 0
  If *bin And binlen
    maxlen = binlen * 3                   ; lnge berechnen; ungnstigster fall muss angenommen werden: JEDES zeichen muss durch =xx ersetzt werden
    If linelen = #PB_Any                  ; kein zeilenumbruch
      lines   = 1                         ; nur eine zeile
      newlen  = maxlen + 5                ; zeilenlnge mit kodieren zeilenumbrchen
      linelen = maxlen
    Else  
      lines  = Int(maxlen / linelen) + 1  ; gesamtzahl der zeilen schtzen, exakt ist es nicht vorherzusagen
      newlen = maxlen + (lines * 3) + 2   ; gesamtlnge schtzen (inkl. crlf)
    EndIf
    *encbin = AllocateMemory(newlen)
    If *encbin
      *a   = *encbin
      *b   = *bin
      llen = 0
      For i = 1 To binlen           ; alle Zeichen abklappern
        c = PeekA(*b) : *b + 1       ; Zeichen auslesen
        If (c < 33) Or (c > 126) Or (c = 61) Or (c = '!') Or (c = '"') Or (c = '#') Or (c = '$') Or (c = '@') Or (c = '[') Or (c = '\') Or (c = ']') Or (c = '^') Or (c = '`') Or (c = '{') Or (c = '|') Or (c = '}') Or (c = '~')
          ; ein kodierungspflichtiges zeichen gefunden -> kodieren
          If (c = 9) Or (c = 32)            ; Space/TAB muss nur direkt vor oder nach einem CRLF kodiert werden
            If (PeekA(*b) = $0d) Or (PeekA(*b - 2) = $0a) Or (llen = 0) Or encodews     ; CRLF war davor bzw ist danach ODER kodierung von WS ist erzwungen
              PokeA(*a, 61)                 : *a + 1                ; =
              PokeA(*a, hx((c & $F0) >> 4)) : *a + 1                ; erstes HEX zeichen
              PokeA(*a, hx( c & $0F))       : *a + 1 : llen + 3     ; zweites HEX zeichen
            Else
              PokeA(*a, c)                  : *a + 1 : llen + 1     ; nicht kodieren, direkt bernehmen
            EndIf           
          Else                              ; war kein WS
            If (c = 10) Or (c = 13)         ; CR oder LF -> direkt bernehmen
              PokeA(*a, c)                  : *a + 1 : llen + 1             
            Else                            ; Zeichen kodieren
              PokeA(*a, 61)                 : *a + 1                ; =
              PokeA(*a, hx((c & $F0) >> 4)) : *a + 1                ; erstes HEX zeichen
              PokeA(*a, hx( c & $0F))       : *a + 1 : llen + 3     ; zweites HEX zeichen
            EndIf
          EndIf
        Else      ; nicht kodierungspflichtig -> direkt bernehmen
          PokeA(*a, c)                      : *a + 1 : llen + 1
        EndIf
        If llen > (linelen - 3)             ; zeilenumbruch, so dass max linelen-zeichen lange zeilen entstehen
          PokeA(*a, 61)                     : *a + 1      ; ein "soft" CRLF einfgen -. diese werden beim dekodieren ignoriert
          PokeW(*a, $0a0d)                  : *a + 2
          llen = 0
        EndIf
      Next i
      If linelen    ; in der letzten zeile ist noch mindestens ein zeichen, also CRLF einfgen; anderenfalls wrden CRLFCRLF drin sein - und das geht nicht
        PokeW(*a, $0a0d)                    : *a + 2 : llen = 0
      EndIf
      maxlen = *a - *encbin       ; echte Zielgre berechnen
    EndIf
  EndIf
  If *encbin    
    PokeI(*enclen, maxlen)
  Else
    PokeI(*enclen, 0) 
  EndIf
  ProcedureReturn *encbin
EndProcedure
Procedure.i ____MSG_EncodeQuotedPrintableStr(text.s, len.i, *enclen, linelen.i = 75, encodews.b = #False)    ; QuotedPrintable Encoder, der auch Zeilenumbrche einfgt (Stringrckgabe)  
  Protected *res, tlen.i, *bin
  
  *res = #Null
  If text And len
    CompilerIf #PB_Compiler_Unicode
      *bin = AllocateMemory(len + 2)
      If *bin
        PokeS(*bin, text, len, #PB_Ascii)
        *res = ____MSG_EncodeQuotedPrintable(*bin, len, @tlen, linelen, encodews)
        FreeMemory(*bin)
      EndIf
    CompilerElse
      *res = ____MSG_EncodeQuotedPrintable(@text, len, @tlen, linelen, encodews)
    CompilerEndIf
  EndIf
  If *res
    PokeI(*enclen, tlen)
  Else
    PokeI(*enclen, 0)
  EndIf
  
  ProcedureReturn *res
EndProcedure
Procedure.s ____MSG_EncodeQuotedPrintableStrToStr(text.s)                             ; Quoted Printable Encoder (Stringrckgabe)
  Protected *res, elen.i, res.s
  
  res = ""
  If text
    *res = ____MSG_EncodeQuotedPrintableStr(text, Len(text), @elen, #PB_Any, #True)
    If *res
      res = PeekS(*res, elen, #PB_Ascii)
      FreeMemory(*res)  
    EndIf
  EndIf
  
  ProcedureReturn res
EndProcedure
Procedure.s ____MSG_GenBoundary()                                                     ; Boundary-Generator fr Multipart-Mails
  Protected dt.i, bnd.s
  
  ; die Boundary erstellen
  ; Format: Boundary_YYYMDDhhmmss_RND_
  ; YYY Jahr, M Monat, DD Tag, hh Stunde, mm Minute, ss Sekunde - jeweils in HEX-Format mit entsprechender Zeichenanzahl
  ; RND zufllige 3-Stellige HEX-Zahl) zwischen 000 und FFF
  ; dadurch wird gesichert, das in einer Mail, die mehrere Parts enthlt, jeder Part eine eigene Boundary erhlt
  
  dt  = Date()
  bnd = "Boundary_" + RSet(Hex(Year(dt)), 3, "0") + RSet(Hex(Month(dt)), 1) + RSet(Hex(Day(dt)), 2, "0") + RSet(Hex(Hour(dt)), 2, "0") + RSet(Hex(Minute(dt)), 2, "0") + RSet(Hex(Second(dt)), 2, "0") + "_" + RSet(Hex(Random($FFF)), 3, "0") + "_"
  
  ProcedureReturn bnd
EndProcedure
Procedure.s ____MSG_EncodeInline(text.s, charset.s = "", encode.i = #____MSG_ENCODE_AUTO) ;- TODO    ; Inline-Encoder; erzeugt =?...?.?...?= Strings sofern ntig
  Protected res.s, enclen.i, *encbin, a.i, f.s, tlen.i, lines.i, llen.i, codelen.i, pos.i, txt.s, fl.b
  If encode = #____MSG_ENCODE_AUTO
    If ____MSG_NeedEncoding(text, #False)
      encode = #____MSG_ENCODE_QP
    EndIf
  EndIf
  
  If Not charset : charset = ____MSG_GetSysCharset() : EndIf
  codelen = Len(charset) + 7
  pos     = 1
  tlen    = Len(text)
  res     = ""
  fl      = #True
  
  While pos <= tlen
    Select encode
      Case #____MSG_ENCODE_AUTO
        llen = 60
        If llen + pos > tlen
          txt = Mid(text, pos)
          pos = tlen + 1
        Else
          txt = Mid(text, pos, llen)
          pos + llen
        EndIf
      Case #____MSG_ENCODE_B64
        llen = 40 - codelen
        If llen + pos > tlen
          txt = Mid(text, pos)
          pos = tlen + 1
        Else
          txt = Mid(text, pos, llen)
          pos + llen
        EndIf
        *encbin = ____MSG_EncodeBase64Str(txt, Len(txt), @enclen, #PB_Any)
        If *encbin
          txt = "=?" + charset + "?B?" + ____SUP_TrimWS(PeekS(*encbin, enclen, #PB_Ascii)) + "?="
          FreeMemory(*encbin)
        EndIf
      Case #____MSG_ENCODE_QP
        llen = ____MSG_MaxCharCountForQPLineLen(text, 60 - codelen, pos)
        If llen
          txt  = Mid(text, pos, llen)
          pos  + llen
          *encbin = ____MSG_EncodeQuotedPrintableStr(txt, Len(txt), @enclen, #PB_Any, #True)
          If *encbin
            txt = "=?" + charset + "?Q?" + ____SUP_TrimWS(ReplaceString(PeekS(*encbin, enclen, #PB_Ascii), Chr(32), "_")) + "?="
            FreeMemory(*encbin)
          EndIf
        Else
          txt  = Mid(text, pos)
        EndIf
    EndSelect
    If fl
      fl = #False
      res + txt
    Else
      res + Chr(13) + Chr(10) + Chr(9) + txt
    EndIf
  Wend
  ProcedureReturn res
EndProcedure
;} 
;{ message building
;- message building
Procedure.b ____MSG_AddHeader(*msg.____MSG_MimePart, hdr.s, value.s)                  ; Header hinzufgen hdr=ABC value=GHI -> "ABC: GHI"
  Protected uhdr.s
  
  If *msg
    uhdr                              = UCase(hdr)
    *msg\Header(uhdr)\dat(uhdr)\key   = hdr
    *msg\Header(uhdr)\dat(uhdr)\value = value
    ProcedureReturn #True
  EndIf
  ProcedureReturn #False  
EndProcedure
Procedure.b ____MSG_AddHeaderValue(*msg.____MSG_MimePart, hdr.s, key.s, value.s)      ; Header hinzufgen hdr=ABC key=DEF value=GHI -> "ABC: DEF=GHI;"
  Protected uhdr.s, ukey.s
  
  If *msg
    uhdr = UCase(hdr)
    ukey = UCase(key)
    *msg\Header(uhdr)\dat(ukey)\key   = key
    *msg\Header(uhdr)\dat(ukey)\value = value
    ProcedureReturn #True
  EndIf
  ProcedureReturn #False  
EndProcedure
Procedure.s ____MSG_BuildHeader(*msg.____MSG_MimePart)                                ; fgt eine Header-MAP zu einem Headerstring zusammen
  Protected hdr.s, key.s, subkey.s, dat.s, subhdr.s, usubkey.s, ukey.s
  
  hdr = ""
  If *msg
    ForEach *msg\Header()
      ukey   = MapKey(*msg\Header())
      key    = *msg\Header()\dat(ukey)\key
      subhdr = ""
      ForEach *msg\Header()\dat()
        usubkey = MapKey(*msg\Header()\dat())
        subkey  = *msg\Header()\dat()\key
        dat     = *msg\Header()\dat()\value
        If usubkey = ukey
          If subhdr
            subhdr = dat + ";" + Chr(13) + Chr(10) + Chr(9) + subhdr
          Else
            subhdr = dat
          EndIf
        Else
          If subhdr
            subhdr + ";" + Chr(13) + Chr(10) + Chr(9)
          EndIf
          subhdr + subkey + "=" + dat
        EndIf
      Next
      If hdr : hdr + Chr(13) + Chr(10) : EndIf        
      hdr + key + ": " + subhdr
    Next
  EndIf
  
  ProcedureReturn hdr
EndProcedure
Procedure.i ____MSG_CalcHeaderSize(*msg.____MSG_MimePart)                             ; Berechnet die Gre des Headers in Zeichenanzahl
  Protected key.i, dat.i, subkey.i, ukey.s, usubkey.s, subhdr.i, hdr.i
  
  hdr = 0
  If *msg
    ForEach *msg\Header()
      ukey   = MapKey(*msg\Header())
      key    = Len(*msg\Header()\dat(ukey)\key)
      subhdr = 0
      ForEach *msg\Header()\dat()
        usubkey = MapKey(*msg\Header()\dat())
        subkey  = Len(*msg\Header()\dat()\key)
        dat     = Len(*msg\Header()\dat()\value)
        If usubkey = ukey
          If subhdr
            subhdr + dat + 4
          Else
            subhdr = dat
          EndIf
        Else
          If subhdr
            subhdr + 4
          EndIf
          subhdr + subkey + 1 + dat
        EndIf
      Next
      If hdr : hdr + 2 : EndIf
      hdr + key + 2 + subhdr
    Next
  EndIf
  
  ProcedureReturn hdr
EndProcedure
Procedure.i ____MSG_CalcSize(*msg.____MSG_MimePart)                                   ; Berechnet die Gre der encodierten Message in Bytes, inkl. Header und allen Steuercodes
  Protected res.i, bound.s, bl.i
  
  If *msg
    ____MSG_GetHeaderValue(bound, *msg, "CONTENT-TYPE", "BOUNDARY")   
    res + ____MSG_CalcHeaderSize(*msg)
    If *msg\body
      res + *msg\bodylen + 4
    Else
      res + 2
    EndIf
    If bound
      bl  = Len(bound)
      res + 4 + bl
      ForEach *msg\MimePart()
        res + ____MSG_CalcSize(*msg\MimePart()) + 6 + bl
      Next
      res + 4
    EndIf
  EndIf
  
  ProcedureReturn res
EndProcedure
Procedure.i ____MSG_BuildPart(*msg.____MSG_MimePart, *partlen, addbufsize.i = 0)      ; Generiert einen Messagepart inkl. Header und Body
  Protected *src, newlen.i, header.s, *partsrc, bound.s, *srcpos, bl.i, hl.i, plen.i
  
  header = ""
  bound  = ""
  plen   = 0
  newlen = ____MSG_CalcSize(*msg) + addbufsize
  If newlen
    *src = AllocateMemory(newlen)   
    If *src
      ____MSG_GetHeaderValue(bound, *msg, "CONTENT-TYPE", "BOUNDARY")
      *srcpos = *src
      header  = ____MSG_BuildHeader(*msg)
      bl      = Len(bound)
      hl      = Len(header)
      PokeS(*srcpos, header, hl, #PB_Ascii)          : *srcpos + hl
      If *msg\body
        PokeL(*srcpos, $0a0d0a0d)                    : *srcpos + 4
        CopyMemory(*msg\body, *srcpos, *msg\bodylen) : *srcpos + *msg\bodylen
      Else
        PokeW(*srcpos, $0a0d)                        : *srcpos + 2
      EndIf     
      If bound
        PokeL(*srcpos, $2d2d0a0d)                    : *srcpos + 4
        PokeS(*srcpos, bound, bl, #PB_Ascii)         : *srcpos + bl
        ForEach *msg\MimePart()
          *partsrc = ____MSG_BuildPart(*msg\MimePart(), @plen)
          If *partsrc
            PokeW(*srcpos, $0a0d)                    : *srcpos + 2
            CopyMemory(*partsrc, *srcpos, plen)      : *srcpos + plen
            PokeL(*srcpos, $2d2d0a0d)                : *srcpos + 4
            PokeS(*srcpos, bound, bl, #PB_Ascii)     : *srcpos + bl
            FreeMemory(*partsrc)
          EndIf
        Next
        PokeL(*srcpos, $0a0d2d2d)                    : *srcpos + 4
      EndIf
      plen = *srcpos - *src
    EndIf
  EndIf
  If *src
    PokeL(*partlen, plen)
  Else
    PokeL(*partlen, 0)
  EndIf
  ProcedureReturn *src
EndProcedure
Procedure.b ____MSG_BuildMessage(*msg.____MSG_Message)                                ; Generiert die Message inkl CRLF Abschluss
  Protected newlen.i, *src
  
  *src = ____MSG_BuildPart(*msg, @newlen, 3)
  If *src
    PokeW(*src + newlen, $0a0d) : newlen + 2
    PokeA(*src + newlen, 0)     : newlen + 1
    *msg\src = *src
    ProcedureReturn #True
  EndIf
  ProcedureReturn #False
EndProcedure
Procedure.b ____MSG_SetBodyBinary(*part.____MSG_MimePart, *src, srclen.i, name.s, filename.s, id.s = "", type.i = #____MSG_TYPE_ATTACHMENT)       ; setzt den Body eines Parts mit Binrdaten (diese werden automatisch Base64 encodiert)
  Protected len.i

  If *part And *src And srclen
    ____MSG_AddHeader(*part, "Content-Type", "application/force-download")
    ____MSG_AddHeader(*part, "Content-Transfer-Encoding", "base64")
    If name     : ____MSG_AddHeaderValue(*part, "Content-Type", "name", ____MSG_AddQuotesIfNeeded(name))                : EndIf
    If filename : ____MSG_AddHeaderValue(*part, "Content-Disposition", "filename", ____MSG_AddQuotesIfNeeded(filename)) : EndIf
    Select type
      Case #____MSG_TYPE_INLINE
        ____MSG_AddHeader(*part, "Content-Disposition", "inline")
        ____MSG_AddHeader(*part, "Content-ID", "<"+id+">")
      Default
        ____MSG_AddHeader(*part, "Content-Disposition", "attachment") 
    EndSelect
    
    *part\body    = ____MSG_EncodeBase64(*src, srclen, @len)
    *part\bodylen = len
    *part\justptr = #False
    
    If *part\bodylen : ProcedureReturn #True : EndIf  
  EndIf 
  ProcedureReturn #False
EndProcedure
Procedure.b ____MSG_SetBodyText(*part.____MSG_MimePart, body.s, type.i = #____MSG_TYPE_PLAIN, charset.s = "", encode.i = #____MSG_ENCODE_AUTO)    ; setzt den Body eines Parts als ASCII-String, der ntigenfalls/erzwungen codiert wird
  Protected len.i

  If *part
    Select type
      Case #____MSG_TYPE_PLAIN  :   ____MSG_AddHeader(*part, "Content-Type", "text/plain")
      Case #____MSG_TYPE_HTML   :   ____MSG_AddHeader(*part, "Content-Type", "text/html")
      Default             :   ____MSG_AddHeader(*part, "Content-Type", "text/plain")
    EndSelect
    
    If Not charset : charset = ____MSG_GetSysCharset() : EndIf
    
    ____MSG_AddHeaderValue(*part, "Content-Type", "charset", ____MSG_AddQuotesIfNeeded(charset))      
        
    If encode = #____MSG_ENCODE_AUTO
      If ____MSG_NeedEncoding(body)
        encode = #____MSG_ENCODE_QP
      EndIf
    EndIf
      
    Select encode
      Case #____MSG_ENCODE_B64 
        ____MSG_AddHeader(*part, "Content-Transfer-Encoding", "base64")
        *part\body    = ____MSG_EncodeBase64Str(body, Len(body), @len)
        *part\bodylen = len
        *part\justptr = #False
      Case #____MSG_ENCODE_QP
        ____MSG_AddHeader(*part, "Content-Transfer-Encoding", "quoted-printable")
        *part\body    = ____MSG_EncodeQuotedPrintableStr(body, Len(body), @len)
        *part\bodylen = len
        *part\justptr = #False
      Default
        ____MSG_AddHeader(*part, "Content-Transfer-Encoding", "8bit")
        len           = Len(body)
        *part\body    = AllocateMemory(len + 4)
        If *part\body
          *part\bodylen = len + 2
          PokeS(*part\body, body, len, #PB_Ascii)
          PokeW(*part\body + len, $0a0d)
        Else
          *part\bodylen = 0
        EndIf
        *part\justptr = #False
    EndSelect
    If *part\bodylen : ProcedureReturn #True : EndIf  
  EndIf 
  ProcedureReturn #False
EndProcedure
Procedure.i ____MSG_SetMultipart(*msg.____MSG_MimePart, type.i = #____MSG_TYPE_MIXED)                                                             ; setzt den Multipart-Header + Boundary eines Parts
  If *msg
    Select type
      Case #____MSG_TYPE_ALTERNATIVE  : ____MSG_AddHeader(*msg, "Content-Type", "multipart/alternative")
      Case #____MSG_TYPE_RELATED      : ____MSG_AddHeader(*msg, "Content-Type", "multipart/related")
      Default                   : ____MSG_AddHeader(*msg, "Content-Type", "multipart/mixed")
    EndSelect   
    ____MSG_AddHeaderValue(*msg, "Content-Type", "boundary", ____MSG_GenBoundary())
    *msg\body    = #Null
    *msg\bodylen = 0
    *msg\justptr = #False
  EndIf
  
  ProcedureReturn *msg
EndProcedure
Procedure.i ____MSG_AddMultipart(*msg.____MSG_MimePart, type.i = #____MSG_TYPE_MIXED)                                                             ; hngt einen neuen Part an die Mail an und setzt den Multipart-Header + Boundary
  Protected *part.____MSG_MimePart
  
  *part = #Null
  If *msg
    AddElement(*msg\MimePart())
    *part = *msg\MimePart()
    If *part
      ____MSG_SetMultipart(*part, Type)
      ProcedureReturn *part
    EndIf
  EndIf
  
  ProcedureReturn #Null
EndProcedure
Procedure.i ____MSG_AddPartHTML(*msg.____MSG_MimePart, html.s, charset.s = "", encode.i = #____MSG_ENCODE_AUTO)                                   ; fgt einen html-part der Mail hinzu und setzt gleich den (ggf codierten) Body
  Protected *part.____MSG_MimePart
  
  *part = #Null
  If *msg
    AddElement(*msg\MimePart())
    *part = *msg\MimePart()
    If *part
      If charset = "" : charset = ____MSG_GetHTMLCharset(html) : EndIf
      If ____MSG_SetBodyText(*part, html, #____MSG_TYPE_HTML, charset, encode)
        ProcedureReturn *part
      EndIf
      DeleteElement(*msg\MimePart())
    EndIf
  EndIf
  
  ProcedureReturn #Null
EndProcedure
Procedure.i ____MSG_AddPartText(*msg.____MSG_MimePart, text.s, charset.s = "", encode.i = #____MSG_ENCODE_AUTO)                                   ; fgt einen PlainText-part der Mail hinzu und setzt gleich den (ggf codierten) Body
  Protected *part.____MSG_MimePart
  
  *part = #Null
  If *msg
    AddElement(*msg\MimePart())
    *part = *msg\MimePart()
    If *part
      If ____MSG_SetBodyText(*part, text, #____MSG_TYPE_PLAIN, charset, encode)
        ProcedureReturn *part
      EndIf
      DeleteElement(*msg\MimePart())
    EndIf
  EndIf
  
  ProcedureReturn #Null
EndProcedure
Procedure.i ____MSG_AddPartBinary(*msg.____MSG_MimePart, *src, srclen.i, name.s, filename.s, id.s = "", type.i = #____MSG_TYPE_ATTACHMENT)        ; fgt einen attachment-part der Mail hinzu und setzt gleich den base64 codierten Body
  Protected *part.____MSG_MimePart
  
  *part = #Null
  If *msg
    AddElement(*msg\MimePart())
    *part = *msg\MimePart()
    If *part
      If ____MSG_SetBodyBinary(*part, *src, srclen, name, GetFilePart(filename), id, type)
        ProcedureReturn *part
      EndIf
      DeleteElement(*msg\MimePart())
    EndIf
  EndIf
  
  ProcedureReturn #Null
EndProcedure
Procedure.i ____MSG_AddPartBinaryFile(*msg.____MSG_MimePart, name.s, filename.s, id.s = "", type.i = #____MSG_TYPE_ATTACHMENT)                    ; fgt einen attachment-part aus einer datei der Mail hinzu und setzt gleich den base64 codierten Body
  Protected file.i, length.i, bytes.i, *txt, *part.____MSG_MimePart
  
  *part = #Null
  If *msg
    file     = ReadFile(#PB_Any, filename)
    If IsFile(file)
      length = Lof(file)
      If length > 0
        *txt = AllocateMemory(length)
        If *txt
          bytes = ReadData(file, *txt, length)
          If bytes = length
            *part = ____MSG_AddPartBinary(*msg, *txt, length, name, filename, id, type)
          EndIf
          FreeMemory(*txt)
        EndIf
      EndIf
      CloseFile(file)
    EndIf   
  EndIf
  ProcedureReturn *part
EndProcedure
;}
;{ set message data
;- set message data
; den entsprechenden Header setzen bzw ersetzen
Procedure.b ____MSG_SetContentType(*msg.____MSG_MimePart, contenttype.s, contentsubtype.s)
  ProcedureReturn ____MSG_AddHeader(*msg, "Content-Type", contenttype + "/" + contentsubtype)
EndProcedure
Procedure.b ____MSG_SetCharset(*msg.____MSG_MimePart, charset.s)  
  ProcedureReturn ____MSG_AddHeaderValue(*msg, "Content-Type", "charset", charset)
EndProcedure
Procedure.b ____MSG_SetEncoding(*msg.____MSG_MimePart, encoding.s)
  ProcedureReturn ____MSG_AddHeader(*msg, "Content-Transfer-Encoding", encoding)
EndProcedure
Procedure.b ____MSG_SetBoundary(*msg.____MSG_MimePart, boundary.s)
  ProcedureReturn ____MSG_AddHeaderValue(*msg, "Content-Type", "boundary", ____MSG_AddQuotesIfNeeded(boundary))
EndProcedure
Procedure.b ____MSG_SetContentDisposition(*msg.____MSG_MimePart, contentdisposition.s)
  ProcedureReturn ____MSG_AddHeader(*msg, "Content-Disposition", contentdisposition)
EndProcedure
Procedure.b ____MSG_SetContentName(*msg.____MSG_MimePart, name.s)
  ProcedureReturn ____MSG_AddHeaderValue(*msg, "Content-Type", "name", name)
EndProcedure
Procedure.b ____MSG_SetContentFilename(*msg.____MSG_MimePart, filename.s)
  ProcedureReturn ____MSG_AddHeaderValue(*msg, "Content-Disposition", "filename", filename)
EndProcedure
Procedure.b ____MSG_SetContentID(*msg.____MSG_MimePart, cid.s)
  ProcedureReturn ____MSG_AddHeader(*msg, "Content-ID", cid)
EndProcedure
Procedure.b ____MSG_SetSubject(*msg.____MSG_MimePart, subject.s)
  ProcedureReturn ____MSG_AddHeader(*msg, "Subject", ____MSG_EncodeInline(subject))
EndProcedure
Procedure.b ____MSG_SetFrom(*msg.____MSG_MimePart, from.s)
  ProcedureReturn ____MSG_AddHeader(*msg, "From", from)
EndProcedure
Procedure.b ____MSG_SetCC(*msg.____MSG_MimePart, cc.s)
  ProcedureReturn ____MSG_AddHeader(*msg, "CC", cc)
EndProcedure
Procedure.b ____MSG_SetBCC(*msg.____MSG_Message, bcc.s)
  If *msg
    *msg\bcc = bcc
    ProcedureReturn #True
  EndIf
  ProcedureReturn #False
EndProcedure
Procedure.b ____MSG_SetTo(*msg.____MSG_MimePart, tolist.s)
  ProcedureReturn ____MSG_AddHeader(*msg, "To", tolist)
EndProcedure
Procedure.b ____MSG_SetDateStr(*msg.____MSG_MimePart, date.s)
  ProcedureReturn ____MSG_AddHeader(*msg, "Date", date)
EndProcedure
Procedure.b ____MSG_SetDate(*msg.____MSG_MimePart, date.i)
  ProcedureReturn ____MSG_SetDateStr(*msg, ____DATE_GetRFC2822DateTime(date))
EndProcedure
Procedure.b ____MSG_SetDateNow(*msg.____MSG_MimePart)
  ProcedureReturn ____MSG_SetDateStr(*msg, ____DATE_GetRFC2822DateTime(Date()))
EndProcedure
Procedure.b ____MSG_SetXPriority(*msg.____MSG_MimePart, priority.i)
  ProcedureReturn ____MSG_AddHeader(*msg, "X-Priority", Str(priority))
EndProcedure
Procedure.b ____MSG_SetDispositionNotificationTo(*msg.____MSG_MimePart, dispositionnotificationto.s)
  ProcedureReturn ____MSG_AddHeader(*msg, "Disposition-Notification-To", dispositionnotificationto)
EndProcedure
Procedure.b ____MSG_SetReplyTo(*msg.____MSG_MimePart, replyto.s)
  ProcedureReturn ____MSG_AddHeader(*msg, "Reply-To", replyto)
EndProcedure
;}
;{ Public Functions
;{ Constants
#AWPB_MSG_PRIO_HIGHEST    = #____MSG_PRIORITY_HIGHEST       ;* hchste Prioritt
#AWPB_MSG_PRIO_HIGH       = #____MSG_PRIORITY_HIGH          ;* hohe Prioritt
#AWPB_MSG_PRIO_NORMAL     = #____MSG_PRIORITY_NORMAL        ;* normale Prioritt
#AWPB_MSG_PRIO_LOW        = #____MSG_PRIORITY_LOW           ;* niedrige Prioritt
#AWPB_MSG_PRIO_LOWEST     = #____MSG_PRIORITY_LOWEST        ;* niedrigste Prioritt

#AWPB_MSG_MP_RELATED      = #____MSG_TYPE_RELATED           ;* multipart/related als Content-Type
#AWPB_MSG_MP_MIXED        = #____MSG_TYPE_MIXED             ;* multipart/mixed als Content-Type
#AWPB_MSG_MP_ALTERNATIVE  = #____MSG_TYPE_ALTERNATIVE       ;* multipart/alternative als Content-Type

#AWPB_MSG_CS_UNKNOWN      = #____MSG_CHARSET_UNKNOWN        ;* unbekanntes Charset, nur zur Ergebnisauswertung
#AWPB_MSG_CS_ISO_8859_15  = #____MSG_CHARSET_ISO_8859_15    ;* Charset ISO-8859-15

#AWPB_MSG_COMP_0          = #____ZIP_COMP_0                 ;* keine Kompression
#AWPB_MSG_COMP_1          = #____ZIP_COMP_1                 ;* Kompressionsstufe 1
#AWPB_MSG_COMP_2          = #____ZIP_COMP_2                 ;* Kompressionsstufe 2
#AWPB_MSG_COMP_3          = #____ZIP_COMP_3                 ;* Kompressionsstufe 3
#AWPB_MSG_COMP_4          = #____ZIP_COMP_4                 ;* Kompressionsstufe 4
#AWPB_MSG_COMP_5          = #____ZIP_COMP_5                 ;* Kompressionsstufe 5
#AWPB_MSG_COMP_6          = #____ZIP_COMP_6                 ;* Kompressionsstufe 6
#AWPB_MSG_COMP_7          = #____ZIP_COMP_7                 ;* Kompressionsstufe 7
#AWPB_MSG_COMP_8          = #____ZIP_COMP_8                 ;* Kompressionsstufe 8
#AWPB_MSG_COMP_9          = #____ZIP_COMP_9                 ;* Kompressionsstufe 9
#AWPB_MSG_COMP_STORE      = #AWPB_MSG_COMP_0                ;* keine Kompression, entspricht #AWPB_MSG_COMP_0 
#AWPB_MSG_COMP_NONE       = #AWPB_MSG_COMP_0                ;* keine Kompression, entspricht #AWPB_MSG_COMP_0 
#AWPB_MSG_COMP_FAST       = #AWPB_MSG_COMP_1                ;* schnellste Kompression, entspricht #AWPB_MSG_COMP_1
#AWPB_MSG_COMP_NORMAL     = #AWPB_MSG_COMP_5                ;* normale Kompression, entspricht #AWPB_MSG_COMP_5
#AWPB_MSG_COMP_MAX        = #AWPB_MSG_COMP_9                ;* hchste Kompression, entspricht #AWPB_MSG_COMP_9
;}
;{ Functions
;** awpb_msg_allocatemessage
;* Fordert Speicher fr ein Message-Objekt an._
;* Rckgabewert ist *Message. Ist der Rckgabewert #Null, wurde kein Objekt angelegt.
Procedure.i AWPB_MSG_AllocateMessage()
  ProcedureReturn ____MSG_AllocMessage()
EndProcedure
;** awpb_msg_clearmessage
;* Lscht den Inhalt des Messageobjektes, da Objekt selber wird nicht freigegeben.
;** .*Message: Zeiger auf ein Message-Objekt
Procedure   AWPB_MSG_ClearMessage(*Message)
  ____MSG_ClearMessage(*Message)
EndProcedure
;** awpb_msg_freemessage
;* Gibt ein Message-Objekt frei.
;** .*Message: Zeiger auf ein Message-Objekt
Procedure   AWPB_MSG_FreeMessage(*Message)
  ____MSG_FreeMessage(*Message)
EndProcedure

;** awpb_msg_setmailsource
;* Setzt den Mailsource fr ein MessageObjekt._
;* Wenn *Message = #Null, wird ein neues Message-Objekt angelegt und zurckgegeben. Wurde ein bestehendes Objekt bergeben, so wird dieses wiederverwendet._
;* Eventuell vorhandene Daten werden gelscht. Ist der Rckgabewert #Null, wurde kein Objekt angelegt.
;** .*Message: Zeiger auf ein Message-Objekt oder #Null
;** .Source.s: Source der eMail
Procedure.i AWPB_MSG_SetMailSource(*Message, Source.s)
  ProcedureReturn ____MSG_SetMailSource(Source, *Message)
EndProcedure
;** awpb_msg_getmailsource
;* Gibt den Mailsource des MessageObjektes als String zurck.
;** .*Message: Zeiger auf ein Message-Objekt
Procedure.s AWPB_MSG_GetMailSource(*Message)
  ProcedureReturn ____MSG_GetMailSource(*Message)
EndProcedure
;** awpb_msg_loadmaileml
;* Ldt den Mailsource fr ein MessageObjekt aus einer Datei._
;* Wenn *Message = #Null, wird ein neues Message-Objekt angelegt und zurckgegeben. Wurde ein bestehendes Objekt bergeben, so wird dieses wiederverwendet._
;* Eventuell vorhandene Daten werden gelscht. Ist der Rckgabewert #Null, wurde kein Objekt angelegt._
;* Als Dateiformat wird eine ASCII-Datei erwartet, die den unbearbeiteten Quellcode enthlt, wie er vom POP-Server geliefert wird.
;** .*Message: Zeiger auf ein Message-Objekt oder #Null
;** .FileName.s: Datei, die den Mailsource enthlt
Procedure.i AWPB_MSG_LoadMailEML(*Message, FileName.s)
  ProcedureReturn ____MSG_LoadRAWMail(FileName, *Message)
EndProcedure
;** awpb_msg_savemaileml
;* Speichert den Mailsource des MessageObjektes in eine Datei._
;* Der Rckgabewert ist bei Erfolg #True, sonst #False._
;* Die Funktion erzeugt eine ASCII-Datei, die den Puren Mailsource enthlt. Evtl vorhandene BCC Daten werden NICHT gespeichert.
;** .*Message: Zeiger auf ein Message-Objekt
;** .FileName.s: Name der Zieldatei
Procedure.b AWPB_MSG_SaveMailEML(*Message, FileName.s)
  ProcedureReturn ____MSG_SaveRAWMail(*Message, FileName)
EndProcedure
;** awpb_msg_loadmail
;* Ldt den Mailsource fr ein MessageObjekt aus einer Datei._
;* Wenn *Message = #Null, wird ein neues Message-Objekt angelegt und zurckgegeben. Wurde ein bestehendes Objekt bergeben, so wird dieses wiederverwendet._
;* Eventuell vorhandene Daten werden gelscht. Ist der Rckgabewert #Null, wurde kein Objekt angelegt._
;* Es wird eine mit AWPB_MSG_SaveMail() erzeugte Datei erwartet.
;** .*Message: Zeiger auf ein Message-Objekt oder #Null
;** .FileName.s: Datei, die den Mailsource enthlt
Procedure.i AWPB_MSG_LoadMail(*Message, FileName.s)
  ProcedureReturn ____MSG_LoadMessage(FileName, *Message)
EndProcedure
;** awpb_msg_savemail
;* Speichert den Mailsource des MessageObjektes in eine Datei._
;* Der Rckgabewert ist bei Erfolg #True, sonst #False._
;* Die Funktion erzeugt eine Spezialdatei, welche auf Wunsch komprimiert wird. Diese Datei lsst sich mit AWPB_MSG_LoadMail() wieder einlesen._
;* Um evtl BCC-Daten zu sichern, muss diese Funktion genutzt werden.
;** .*Message: Zeiger auf ein Message-Objekt
;** .FileName.s: Name der Zieldatei
;** .CompressionLevel.i: Kompressionsstufe_
;* Einer folgender Werte:_
;* <ul><li>#AWPB_MSG_COMP_0</li><li>#AWPB_MSG_COMP_1</li><li>#AWPB_MSG_COMP_2</li><li>#AWPB_MSG_COMP_3</li><li>#AWPB_MSG_COMP_4</li>
;* <li>#AWPB_MSG_COMP_5</li><li>#AWPB_MSG_COMP_6</li><li>#AWPB_MSG_COMP_7</li><li>#AWPB_MSG_COMP_8</li><li>#AWPB_MSG_COMP_9</li>
;* <li>#AWPB_MSG_COMP_STORE</li><li>#AWPB_MSG_COMP_NONE</li><li>#AWPB_MSG_COMP_FAST</li><li>#AWPB_MSG_COMP_NORMAL</li><li>#AWPB_MSG_COMP_MAX</li></ul>
Procedure.b AWPB_MSG_SaveMail(*Message, FileName.s, CompressionLevel.i)
  ProcedureReturn ____MSG_SaveMessage(*Message, FileName, CompressionLevel)
EndProcedure

;** awpb_msg_decodemessage
;* Zerlegt den Mailsource des Messageobjektes. Die einzelnen Headerfelder und Anhnge knnen mit den_
;* AWPB_MSG_Get*()-Funktionen ausgelesen werden._
;* Der Rckgabewert ist bei Erfolg #True, sonst #False.
;** .*Message: Zeiger auf ein Message-Objekt
Procedure.b AWPB_MSG_DecodeMessage(*Message)
  ProcedureReturn ____MSG_AnalyzeMessage(*Message)
EndProcedure
;** awpb_msg_encodemessage
;* Erzeugt aus den Daten des MessageObjektes einen neuen Mailsource, der gespeichert oder per SMTP versendet werden kann._
;* Die einzelnen Headerfelder und Attachments  werden mittels der AWPB_MSG_Set*() bzw AWPB_MSG_AddPart*()-Funktionen gesetzt._
;* Der Rckgabewert ist bei Erfolg #True, sonst #False.
;** .*Message: Zeiger auf ein Message-Objekt
Procedure.b AWPB_MSG_EncodeMessage(*Message)
  ProcedureReturn ____MSG_BuildMessage(*Message)
EndProcedure

;** awpb_msg_findpartcid
;* Findet den Messagepart, dessen Content-ID gegeben ist._
;* Zurckgegeben wird ein MessagePart-Objekt. Wird kein passender Part gefunden, wird #Null zurckgegeben.
;** .*MessagePart: Zeiger auf ein Message- oder MessagePart-Objekt
;** .ContentID.s: Content-ID nach der gesucht wird
;** .CaseSensitive.b: Gro/Kleinschreibung bercksichtigen. Wenn #True, dann ist A <> a, wenn #False ist A = a
Procedure.i AWPB_MSG_FindPartCID(*MessagePart, ContentID.s, CaseSensitive.b = #True)
  ProcedureReturn ____MSG_FindPartCID(*MessagePart, ContentID, CaseSensitive)
EndProcedure
;** awpb_msg_findpartname
;* Findet den Messagepart, dessen Name gegeben ist._
;* Zurckgegeben wird ein MessagePart-Objekt. Wird kein passender Part gefunden, wird #Null zurckgegeben.
;** .*MessagePart: Zeiger auf ein Message- oder MessagePart-Objekt
;** .Name.s: Name nach dem gesucht wird
;** .CaseSensitive.b: Gro/Kleinschreibung bercksichtigen. Wenn #True, dann ist A <> a, wenn #False ist A = a
Procedure.i AWPB_MSG_FindPartName(*MessagePart, Name.s, CaseSensitive.b = #True)
  ProcedureReturn ____MSG_FindPartName(*MessagePart, Name, CaseSensitive)
EndProcedure
;** awpb_msg_findpartfilename
;* Findet den Messagepart, dessen Dateiname gegeben ist._
;* Zurckgegeben wird ein MessagePart-Objekt. Wird kein passender Part gefunden, wird #Null zurckgegeben.
;** .*MessagePart: Zeiger auf ein Message- oder MessagePart-Objekt
;** .FileName.s: FileName nach dem gesucht wird
;** .CaseSensitive.b: Gro/Kleinschreibung bercksichtigen. Wenn #True, dann ist A <> a, wenn #False ist A = a
Procedure.i AWPB_MSG_FindPartFileName(*MessagePart, FileName.s, CaseSensitive.b = #True)
  ProcedureReturn ____MSG_FindPartFileName(*MessagePart, FileName, CaseSensitive)
EndProcedure
;** awpb_msg_getpartasbin
;* Gibt die Daten des Messageparts als Binrdaten zurck._
;* Sofern diese Quoted-Printable oder Base64 kodiert sind, werden sie zuvor dekodiert._
;* Handelt es sich um Textdaten, knnen sie mir PeekS(,Length ,#PB_ASCII) ausgelesen werden._
;* Zurckgegeben wird ein Zeiger auf die Binrdaten, der mit AWPB_MSG_FreePartMemory() freigegeben werden muss.
;** .*MessagePart: Zeiger auf ein Message- oder MessagePart-Objekt
;** .*Length: Zeiger auf eine Integervariable, in der die Lnge der Daten zurckgegeben wird. Length muss vom Typ .i sein.
Procedure.i AWPB_MSG_GetPartAsBin(*MessagePart, *Length)
  If *Length
    ProcedureReturn ____MSG_GetPartAsBin(*MessagePart, *Length)
  EndIf
  
  ProcedureReturn #Null
EndProcedure
;** awpb_msg_freepartmemory
;* Gibt den von AWPB_MSG_GetPartAsBin() belegten Speicher wieder frei.
;** .*BinaryPart: Zeiger auf Binrdaten, der von AWPB_MSG_GetPartAsBin() zurckgegeben wurde
Procedure   AWPB_MSG_FreePartMemory(*BinaryPart)
  If *BinaryPart
    FreeMemory(*BinaryPart)
  EndIf
EndProcedure

;** awpb_msg_getplainbody
;* Gibt den text/plain-Part der Mail zurck._
;* Dabei werden Base64 bzw QuotedPrintable kodierte Texte automatisch dekodiert._
;* Falls keine Daten vorhanden sind, wird ein leerer String zurckgegeben.
;** .*Message: Zeiger auf ein Message-Objekt
Procedure.s AWPB_MSG_GetPlainBody(*Message)
  ProcedureReturn ____MSG_GetPlainText(*Message)
EndProcedure
;** awpb_msg_getplainbodyashtml
;* Gibt den text/plain-Part der Mail HTML-Formatiert zurck._
;* Dabei werden Base64 bzw QuotedPrintable kodierte Texte automatisch dekodiert._
;* Falls keine Daten vorhanden sind, wird ein leerer String zurckgegeben.
;** .*Message: Zeiger auf ein Message-Objekt
Procedure.s AWPB_MSG_GetPlainBodyAsHTML(*Message)
  ProcedureReturn ____MSG_GetPlainAsHTML(*Message)
EndProcedure
;** awpb_msg_gethtmlbody
;* Gibt den text/html-Part der Mail zurck._
;* Dabei werden Base64 bzw QuotedPrintable kodierte Texte automatisch dekodiert._
;* Falls keine Daten vorhanden sind, wird ein leerer String zurckgegeben.
;** .*Message: Zeiger auf ein Message-Objekt
Procedure.s AWPB_MSG_GetHTMLBody(*Message)
  ProcedureReturn ____MSG_GetHTML(*Message)
EndProcedure
;** awpb_msg_getsubject
;* Gibt den Betreff der Mail zurck._
;* Dabei werden Base64 bzw QuotedPrintable kodierte Texte automatisch dekodiert._
;* Falls keine Daten vorhanden sind, wird ein leerer String zurckgegeben.
;** .*Message: Zeiger auf ein Message-Objekt
Procedure.s AWPB_MSG_GetSubject(*Message)
  ProcedureReturn ____MSG_GetSubject(*Message)
EndProcedure
;** awpb_msg_getfrom
;* Gibt den Absender der Mail zurck._
;* Dabei werden Base64 bzw QuotedPrintable kodierte Texte automatisch dekodiert._
;* Falls keine Daten vorhanden sind, wird ein leerer String zurckgegeben.
;** .*Message: Zeiger auf ein Message-Objekt
Procedure.s AWPB_MSG_GetFrom(*Message)
  ProcedureReturn ____MSG_GetFrom(*Message)
EndProcedure
;** awpb_msg_getto
;* Gibt den Empfnger der Mail zurck._
;* Dabei werden Base64 bzw QuotedPrintable kodierte Texte automatisch dekodiert._
;* Es wird der komplette Inhalt des To-Headers zurckgegeben._
;* Falls keine Daten vorhanden sind, wird ein leerer String zurckgegeben.
;** .*Message: Zeiger auf ein Message-Objekt
Procedure.s AWPB_MSG_GetTo(*Message)
  ProcedureReturn ____MSG_GetTo(*Message)
EndProcedure
;** awpb_msg_gettomails
;* Gibt die Empfnger der Mail zurck._
;* Dabei werden Base64 bzw QuotedPrintable kodierte Texte automatisch dekodiert._
;* Es werden nur die eMail-Adressen des To-Headers zurckgegeben._
;* Falls keine Daten vorhanden sind, wird ein leerer String zurckgegeben.
;** .*Message: Zeiger auf ein Message-Objekt
Procedure.s AWPB_MSG_GetToMails(*Message)
  ProcedureReturn ____MSG_GetToMails(*Message)
EndProcedure
;** awpb_msg_getcc
;* Gibt die Kopie-Empfnger der Mail zurck._
;* Dabei werden Base64 bzw QuotedPrintable kodierte Texte automatisch dekodiert._
;* Es wird der komplette Inhalt des CC-Headers zurckgegeben._
;* Falls keine Daten vorhanden sind, wird ein leerer String zurckgegeben.
;** .*Message: Zeiger auf ein Message-Objekt
Procedure.s AWPB_MSG_GetCC(*Message)
  ProcedureReturn ____MSG_GetCC(*Message)
EndProcedure
;** awpb_msg_getccmails
;* Gibt die Kopie-Empfnger der Mail zurck._
;* Dabei werden Base64 bzw QuotedPrintable kodierte Texte automatisch dekodiert._
;* Es werden nur die eMail-Adressen des CC-Headers zurckgegeben._
;* Falls keine Daten vorhanden sind, wird ein leerer String zurckgegeben.
;** .*Message: Zeiger auf ein Message-Objekt
Procedure.s AWPB_MSG_GetCCMails(*Message)
  ProcedureReturn ____MSG_GetCCMails(*Message)
EndProcedure
;** awpb_msg_getbcc
;* Gibt die versteckten Empfnger der Mail zurck._
;* Dabei werden Base64 bzw QuotedPrintable kodierte Texte automatisch dekodiert._
;* Es wird der komplette Inhalt des BCC-Feldes zurckgegeben. Wichtig: diese Daten existieren nur,
;* wenn sie vom Benutzer hinzugefgt wurden. Im Mailsource sind sie nicht vorhanden.
;* Falls keine Daten vorhanden sind, wird ein leerer String zurckgegeben.
;** .*Message: Zeiger auf ein Message-Objekt
Procedure.s AWPB_MSG_GetBCC(*Message)
  ProcedureReturn ____MSG_GetBCC(*Message)
EndProcedure
;** awpb_msg_getbccmails
;* Gibt die versteckten Empfnger der Mail zurck._
;* Dabei werden Base64 bzw QuotedPrintable kodierte Texte automatisch dekodiert._
;* Es werden nur die eMail-Adressen des BCC-Feldes zurckgegeben. Wichtig: diese Daten existieren nur,
;* wenn sie vom Benutzer hinzugefgt wurden. Im Mailsource sind sie nicht vorhanden._
;* Falls keine Daten vorhanden sind, wird ein leerer String zurckgegeben.
;** .*Message: Zeiger auf ein Message-Objekt
Procedure.s AWPB_MSG_GetBCCMails(*Message)
  ProcedureReturn ____MSG_GetBCCMails(*Message)
EndProcedure
;** awpb_msg_getpriority
;* Gibt die Prioritt der Mail zurck. (X-Priority)
;* Mgliche Rckgabewerte sind_
;* <ul><li>#AWPB_MSG_PRIO_HIGHEST</li><li>#AWPB_MSG_PRIO_HIGH</li><li>#AWPB_MSG_PRIO_NORMAL</li><li>#AWPB_MSG_PRIO_LOW</li><li>#AWPB_MSG_PRIO_LOWEST</li></ul>_
;* Falls keine Daten vorhanden sind wird #AWPB_MSG_PRIO_NORMAL zurckgegeben.
;** .*Message: Zeiger auf ein Message-Objekt
Procedure.i AWPB_MSG_GetPriority(*Message)
  ProcedureReturn ____MSG_GetXPriority(*Message)
EndProcedure
;** awpb_msg_getdate
;* Gibt das Datum der Mail zurck. Die Rckgabe erfolgt im PB-Date-Format; kann also mit den Datumsfunktionen weiterverarbeitet werden._
;* Falls keine Daten vorhanden sind wird 0 zurckgegeben.
;** .*Message: Zeiger auf ein Message-Objekt
Procedure.i AWPB_MSG_GetDate(*Message)
  ProcedureReturn ____MSG_GetDate(*Message)
EndProcedure
;** awpb_msg_getreplyto
;* Gibt das Reply-To Feld aus dem Mailheader zurck.
;* Falls keine Daten vorhanden sind wird ein leerer String zurckgegeben.
;** .*Message: Zeiger auf ein Message-Objekt
Procedure.s AWPB_MSG_GetReplyTo(*Message)
  ProcedureReturn ____MSG_GetReplyTo(*Message)
EndProcedure
;** awpb_msg_getdispositionnotificationto
;* Gibt das DispositionNotificationTo Feld aus dem Mailheader zurck._
;* Falls keine Daten vorhanden sind wird ein leerer String zurckgegeben.
;** .*Message: Zeiger auf ein Message-Objekt
Procedure.s AWPB_MSG_GetDispositionNotificationTo(*Message)
  ProcedureReturn ____MSG_GetDispositionNotificationTo(*Message)
EndProcedure
;** awpb_msg_getcharset
;* Gibt das Charset des Messageparts zurck._
;* Falls keine Daten vorhanden sind wird ein leerer String zurckgegeben..
;** .*MessagePart: Zeiger auf ein MessagePart- oder ein Message-Objekt
Procedure.s AWPB_MSG_GetCharset(*MessagePart)
  ProcedureReturn ____MSG_GetCharset(*MessagePart)
EndProcedure
;** awpb_msg_getcontentid
;* Gibt die ContentID des Messageparts zurck._
;* Falls keine Daten vorhanden sind wird ein leerer String zurckgegeben.
;** .*MessagePart: Zeiger auf ein MessagePart- oder ein Message-Objekt
Procedure.s AWPB_MSG_GetContentID(*MessagePart)
  ProcedureReturn ____MSG_GetContentID(*MessagePart)
EndProcedure
;** awpb_msg_getcontentdisposition
;* Gibt das ContentDisposition-Feld des Messageparts zurck._
;* Falls keine Daten vorhanden sind wird ein leerer String zurckgegeben.
;** .*MessagePart: Zeiger auf ein MessagePart- oder ein Message-Objekt
Procedure.s AWPB_MSG_GetContentDisposition(*MessagePart)
  ProcedureReturn ____MSG_GetContentDisposition(*MessagePart)
EndProcedure
;** awpb_msg_getcontentname
;* Gibt den ContentNamen des Messageparts zurck._
;* Falls keine Daten vorhanden sind wird ein leerer String zurckgegeben.
;** .*MessagePart: Zeiger auf ein MessagePart- oder ein Message-Objekt
Procedure.s AWPB_MSG_GetContentName(*MessagePart)
  ProcedureReturn ____MSG_GetContentName(*MessagePart)
EndProcedure
;** awpb_msg_getcontentfilename
;* Gibt den Content Dateinamen des Messageparts zurck._
;* Falls keine Daten vorhanden sind wird ein leerer String zurckgegeben.
;** .*MessagePart: Zeiger auf ein MessagePart- oder ein Message-Objekt
Procedure.s AWPB_MSG_GetContentFilename(*MessagePart)
  ProcedureReturn ____MSG_GetContentFilename(*MessagePart)
EndProcedure
;** awpb_msg_getattachmentlist
;* Erzeugt eine Liste aller Attachments des MessageParts. Werden die Attachments der gesamten Mail gebraucht, 
;* muss stattdessen das MessageObjekt bergeben werden._
;* Die Funktion gibt die Anzahl der gefundenen Attachments zurck._
;* Falls keine Daten vorhanden sind wird die Liste geleert und 0 zurckgegeben.
;** .*MessagePart: Zeiger auf ein MessagePart- oder ein Message-Objekt
;** .Attachments.i: eine Liste, in der die Attachments (als MessagePart-Objekte) gespeichert werden
Procedure.i AWPB_MSG_GetAttachmentList(*MessagePart, List Attachments.i())
  ClearList(Attachments())
  ____MSG_BuildAttachmentList(*MessagePart, Attachments())
  ProcedureReturn ListSize(Attachments())
EndProcedure
;** awpb_msg_saveattachmenttofile
;* Speichert das Attachment in eine Datei._
;* Bei einem Fehler wird #False zurckgegeben, ansonsten #True.
;** .*MessagePart: Zeiger auf ein MessagePart-Objekt, das ein Attachment enthlt
;** .FileName.s: Dateiname (inkl. Pfad), in die das Attachment gespeichert werden soll
Procedure.b AWPB_MSG_SaveAttachmentToFile(*MessagePart, FileName.s)
  ProcedureReturn ____MSG_SavePartToFile(*MessagePart, FileName)
EndProcedure
;** awpb_msg_saveattachmenttofolder
;* Speichert das Attachment in einen Ordner. Als Dateiname wird der Dateiname aus dem Header bernommen._
;* Bei einem Fehler wird #False zurckgegeben, ansonsten #True.
;** .*MessagePart: Zeiger auf ein MessagePart-Objekt, das ein Attachment enthlt
;** .FolderName.s: Ordnername, in dem das Attachment gespeichert werden soll
Procedure.b AWPB_MSG_SaveAttachmentToFolder(*MessagePart, FolderName.s)
  Protected fn.s
  
  If *MessagePart
    fn = ____MSG_GetContentFilename(*MessagePart)
    If fn
      ProcedureReturn ____MSG_SavePartToFile(*MessagePart, ____MSG_BuildPath(FolderName, fn))
    EndIf
  EndIf
  
  ProcedureReturn #False
EndProcedure
;** awpb_msg_saveattachmentstofolder
;* Speichert alle Attachments der Liste in einen Ordner. Als Dateiname wird der Dateiname aus dem jeweiligen Header bernommen._
;* Bei einem Fehler wird #False zurckgegeben, ansonsten #True.
;** .Attachments.i: Liste von MessageParts-Objekten, die z.B. mittels AWPB_MSG_GetAttachmentList erzeugt wurde
;** .FolderName.s: Ordnername, in dem das Attachment gespeichert werden soll
Procedure.b AWPB_MSG_SaveAttachmentsToFolder(List Attachments.i(), FolderName.s)
  Protected *part, ok.b
  
  ok = #True
  ForEach Attachments()
    *part = Attachments()
    If Not AWPB_MSG_SaveAttachmentToFolder(*part, FolderName) : ok = #False : EndIf
  Next
  
  ProcedureReturn ok
EndProcedure

;** awpb_msg_setsubject
;* Setzt den Betreff der Message. Ist der Betreff bereits gesetzt, so wird er ersetzt.
;** .*Message: Zeiger auf ein Message-Objekt
;** .Subject.s: neuer Betreff
Procedure   AWPB_MSG_SetSubject(*Message, Subject.s)
  ____MSG_SetSubject(*Message, Subject)
EndProcedure
;** awpb_msg_setfrom
;* Setzt den Absender der Message. Ist der Absender bereits gesetzt, so wird er ersetzt.
;** .*Message: Zeiger auf ein Message-Objekt
;** .From.s: neuer Absender (eMail)
Procedure   AWPB_MSG_SetFrom(*Message, From.s)
  ____MSG_SetFrom(*Message, From)
EndProcedure
;** awpb_msg_setto
;* Setzt die Empfnger (To) der Message. Ist das Feld bereits gesetzt, so wird es ersetzt.
;** .*Message: Zeiger auf ein Message-Objekt
;** .ToList.s: neue Empfnger (eMail, bei mehreren mit "," getrennt)
Procedure   AWPB_MSG_SetTo(*Message, ToList.s)
  ____MSG_SetTo(*Message, ToList)
EndProcedure
;** awpb_msg_setcc
;* Setzt die Kopie-Empfnger (CC) der Message. Ist das Feld bereits gesetzt, so wird es ersetzt.
;** .*Message: Zeiger auf ein Message-Objekt
;** .CCList.s: neue Empfnger (eMail, bei mehreren mit "," getrennt)
Procedure   AWPB_MSG_SetCC(*Message, CCList.s)
  ____MSG_SetCC(*Message, CCList)
EndProcedure
;** awpb_msg_setbcc
;* Setzt die versteckten Empfnger (BCC) der Message. Ist das Feld bereits gesetzt, so wird es ersetzt._
;* Wichtig: diese Daten werden nur bei Benutzung der Funktion AWPB_MSG_SaveMail() gespeichert bzw bei AWPB_MSG_LoadMail() eingelesen,_
;* da sie im Mailbody nicht vorhanden sind
;** .*Message: Zeiger auf ein Message-Objekt
;** .BCCList.s: neue Empfnger (eMail, bei mehreren mit "," getrennt)
Procedure   AWPB_MSG_SetBCC(*Message, BCCList.s)
  ____MSG_SetBCC(*Message, BCCList)
EndProcedure
;** awpb_msg_setpriority
;* Setzt die Prioritt (X_Priority) der Message. Ist das Feld bereits gesetzt, so wird es ersetzt.
;** .*Message: Zeiger auf ein Message-Objekt
;** .Priority.i: neue Prioritt, einer der folgenden Werte:_
;* <ul><li>#AWPB_MSG_PRIO_HIGHEST</li><li>#AWPB_MSG_PRIO_HIGH</li><li>#AWPB_MSG_PRIO_NORMAL</li><li>#AWPB_MSG_PRIO_LOW</li><li>#AWPB_MSG_PRIO_LOWEST</li></ul>
Procedure   AWPB_MSG_SetPriority(*Message, Priority.i)
  ____MSG_SetXPriority(*Message, Priority)
EndProcedure
;** awpb_msg_setdate
;* Setzt das Datum der Message. Ist das Feld bereits gesetzt, so wird es ersetzt.
;** .*Message: Zeiger auf ein Message-Objekt
;** .DateValue.i: neues Datum, kann mit der Date()-Funktion von PB ermittelt werden
Procedure   AWPB_MSG_SetDate(*Message, DateValue.i)
  ____MSG_SetDate(*Message, DateValue)
EndProcedure
;** awpb_msg_setreplyto
;* Setzt das Reply-To-Feld der Message. Ist das Feld bereits gesetzt, so wird es ersetzt.
;** .*Message: Zeiger auf ein Message-Objekt
;** .ReplyTo.s: neue Adresse
Procedure   AWPB_MSG_SetReplyTo(*Message, ReplyTo.s)
  ____MSG_SetReplyTo(*Message, ReplyTo)
EndProcedure
;** awpb_msg_setdispositionnotificationto
;* Setzt das Disposition-Notification-To-Feld der Message. Ist das Feld bereits gesetzt, so wird es ersetzt.
;** .*Message: Zeiger auf ein Message-Objekt
;** .Adr.s: neue Adresse
Procedure   AWPB_MSG_SetDispositionNotificationTo(*Message, Adr.s)
  ____MSG_SetDispositionNotificationTo(*Message, Adr)
EndProcedure
;** awpb_msg_setcharsetname
;* Setzt das Charset-Feld des MessageParts. Ist das Feld bereits gesetzt, so wird es ersetzt.
;** .*MessagePart: Zeiger auf ein MessagePart-Objekt
;** .CharsetName.s: Name des Charsets (z.B. Rckgabewert von AWPB_MSG_GetSysCharsetName())
Procedure   AWPB_MSG_SetCharsetName(*MessagePart, CharsetName.s)
  ____MSG_SetCharset(*MessagePart, CharsetName)
EndProcedure
;** awpb_msg_setcharsetcode
;* Setzt das Charset-Feld des MessageParts. Ist das Feld bereits gesetzt, so wird es ersetzt.
;** .*MessagePart: Zeiger auf ein MessagePart-Objekt
;** .CharsetCode.i: Code des Charsets, entweder der Rckgabewert von AWPB_MSG_GetSysCharsetCode() oder einer der folgenden_
;* <ul><li>#AWPB_MSG_CS_ISO_8859_15</li></ul>
Procedure   AWPB_MSG_SetCharsetCode(*MessagePart, CharsetCode.i)
  ____MSG_SetCharset(*MessagePart, ____MSG_GetCharsetName(CharsetCode))
EndProcedure
;** awpb_msg_setcontentid
;* Setzt das Content-ID-Feld des MessageParts. Ist das Feld bereits gesetzt, so wird es ersetzt.
;** .*MessagePart: Zeiger auf ein MessagePart-Objekt
;** .ContentID.s: ContentID des MessageParts
Procedure   AWPB_MSG_SetContentID(*MessagePart, ContentID.s)
  ____MSG_SetContentID(*MessagePart, ContentID)
EndProcedure

;** awpb_msg_setmultipart
;* Markiert das bergebenen MessageObjekt als MultiPart-Message._
;* Zurckgegeben wird das MessageObjekt selber.
;** .*Message: Zeiger auf ein Message-Objekt
;** .Type.i: Typ des Multiparts, einer der folgenden Werte:_
;* <ul><li>#AWPB_MSG_MP_RELATED</li><li>#AWPB_MSG_MP_MIXED</li><li>#AWPB_MSG_MP_ALTERNATIVE</li></ul>
Procedure.i AWPB_MSG_SetMultipart(*Message, Type.i)
  ProcedureReturn ____MSG_SetMultipart(*Message, Type)
EndProcedure
;** awpb_msg_addmultipart
;* Fgt dem bergebenen MessagePart-Objekt einen SubPart hinzu, der selber ein MultiPart ist._
;* Zurckgegeben wird das neue MessagePart-Objekt oder #Null im Fehlerfall.
;** .*MessagePart: Zeiger auf ein Message-Objekt
;** .Type.i: Typ des Multiparts, einer der folgenden Werte:_
;* <ul><li>#AWPB_MSG_MP_RELATED</li><li>#AWPB_MSG_MP_MIXED</li><li>#AWPB_MSG_MP_ALTERNATIVE</li></ul>
Procedure.i AWPB_MSG_AddMultipart(*MessagePart, Type.i)
  ProcedureReturn ____MSG_AddMultipart(*MessagePart, Type)
EndProcedure
;** awpb_msg_setbodyhtml
;* Setzt den Body des bergebenen MessageParts als den bergebenen HTML-Code. Ein eigenes Charset kann
;* angegeben werden, wird ein leerer String "" angegeben, wird das StandardCharset vom System genommen._
;* Der Text wird automatisch codiert (QuotedPrintable bzw Base64) sofern erforderlich._
;* Zurckgegeben wird das MessageObjekt selber.
;** .*MessagePart: Zeiger auf ein Message-Objekt
;** .HTMLCode.s: HTML-Code
;** .CustomCharset.s: Name des Charsets oder leerer String
Procedure.i AWPB_MSG_SetBodyHTML(*MessagePart, HTMLCode.s, CustomCharset.s = "")
  ProcedureReturn ____MSG_SetBodyText(*MessagePart, HTMLCode, #____MSG_TYPE_HTML, CustomCharset)
EndProcedure
;** awpb_msg_addparthtml
;* Fgt dem bergebenen MessagePart (Multipart) einen HTML-Part an mit dem bergebenen HTML-Code. Ein eigenes Charset kann
;* angegeben werden, wird ein leerer String "" angegeben, wird das StandardCharset vom System genommen._
;* Der Text wird automatisch codiert (QuotedPrintable bzw Base64) sofern erforderlich._
;* Zurckgegeben wird das neue MessageObjekt oder #Null im Fehlerfall.
;** .*MessagePart: Zeiger auf ein Message-Objekt
;** .HTMLCode.s: HTML-Code
;** .CustomCharset.s: Name des Charsets oder leerer String
Procedure.i AWPB_MSG_AddPartHTML(*MessagePart, HTMLCode.s, CustomCharset.s = "")
  ProcedureReturn ____MSG_AddPartHTML(*MessagePart, HTMLCode, CustomCharset)
EndProcedure
;** awpb_msg_setbodyplaintext
;* Setzt den Body des bergebenen MessageParts als den bergebenen Text. Ein eigenes Charset kann
;* angegeben werden, wird ein leerer String "" angegeben, wird das StandardCharset vom System genommen._
;* Der Text wird automatisch codiert (QuotedPrintable bzw Base64) sofern erforderlich._
;* Zurckgegeben wird das MessageObjekt selber.
;** .*MessagePart: Zeiger auf ein Message-Objekt
;** .PlainText.s: Text
;** .CustomCharset.s: Name des Charsets oder leerer String
Procedure.i AWPB_MSG_SetBodyPlainText(*MessagePart, PlainText.s, CustomCharset.s = "")
  ProcedureReturn ____MSG_SetBodyText(*MessagePart, PlainText, #____MSG_TYPE_PLAIN, CustomCharset)
EndProcedure
;** awpb_msg_addpartplaintext
;* Fgt dem bergebenen MessagePart (Multipart) einen Text-Part an mit dem bergebenen Text. Ein eigenes Charset kann
;* angegeben werden, wird ein leerer String "" angegeben, wird das StandardCharset vom System genommen._
;* Der Text wird automatisch codiert (QuotedPrintable bzw Base64) sofern erforderlich._
;* Zurckgegeben wird das neue MessageObjekt oder #Null im Fehlerfall.
;** .*MessagePart: Zeiger auf ein Message-Objekt
;** .PlainText.s: Text
;** .CustomCharset.s: Name des Charsets oder leerer String
Procedure.i AWPB_MSG_AddPartPlainText(*MessagePart, PlainText.s, CustomCharset.s = "")
  ProcedureReturn ____MSG_AddPartText(*MessagePart, PlainText, CustomCharset)
EndProcedure
;** awpb_msg_setbodybinary
;* Setzt den Body des bergebenen MessageParts als den bergebenen HTML-Code. Ein eigenes Charset kann
;* angegeben werden, wird ein leerer String "" angegeben, wird das StandardCharset vom System genommen._
;* Die Binrdaten werden automatisch in Base64 codiert._
;* Zurckgegeben wird das MessageObjekt selber.
;** .*MessagePart: Zeiger auf ein Message-Objekt
;** .*buffer: Zeiger auf die Binrdaten
;** .buflen.i: Lnge der Binrdaten
;** .FileName.s: DateiName, der in den Header eingetragen wird
;** .Name.s: ContentName, der in den Header eingetragen wird
;** .ContentID.s: ContentID, die in den Header eingetragen wird
Procedure.i AWPB_MSG_SetBodyBinary(*MessagePart, *buffer, buflen.i, FileName.s, Name.s, ContentID.s)
  ProcedureReturn ____MSG_SetBodyBinary(*MessagePart, *buffer, buflen, Name, FileName, ContentID)
EndProcedure
;** awpb_msg_addpartbinary
;* Fgt dem bergebenen MessagePart (Multipart) einen Anhang mit den bergebenen Binrdaten hinzu._
;* Die Binrdaten werden automatisch in Base64 codiert._
;* Zurckgegeben wird das neue MessageObjekt oder #Null im Fehlerfall.
;** .*MessagePart: Zeiger auf ein Message-Objekt
;** .*buffer: Zeiger auf die Binrdaten
;** .buflen.i: Lnge der Binrdaten
;** .FileName.s: DateiName, der in den Header eingetragen wird
;** .Name.s: ContentName, der in den Header eingetragen wird
;** .ContentID.s: ContentID, die in den Header eingetragen wird
Procedure.i AWPB_MSG_AddPartBinary(*MessagePart, *buffer, buflen.i, FileName.s, Name.s, ContentID.s)
  ProcedureReturn ____MSG_AddPartBinary(*MessagePart, *buffer, buflen, Name, FileName, ContentID)
EndProcedure
;** awpb_msg_addpartbinaryfile
;* Fgt dem bergebenen MessagePart (Multipart) einen Anhang mit den bergebenen Binrdaten hinzu._
;* Die Binrdaten werden aus der angegebenen Datei eingelesen und automatisch in Base64 codiert._
;* Zurckgegeben wird das neue MessageObjekt oder #Null im Fehlerfall.
;** .*MessagePart: Zeiger auf ein Message-Objekt
;** .FileName.s: DateiName mit kompletten Pfad_
;* Der DateiName ohne Pfad wird automatisch in den Header eingetragen.
;** .Name.s: ContentName, der in den Header eingetragen wird
;** .ContentID.s: ContentID, die in den Header eingetragen wird
Procedure.i AWPB_MSG_AddPartBinaryFile(*MessagePart, FileName.s, Name.s, ContentID.s)
  ProcedureReturn ____MSG_AddPartBinaryFile(*MessagePart, Name, FileName, ContentID)
EndProcedure
  
;** awpb_msg_getcharsetcode
;* Gibt den Code des als String bergebenen Charsets zurck._
;* Falls das Charset unbekannt ist, wird #AWPB_MSG_CS_UNKNOWN zurckgegeben.
;** .CharsetName.s: Name des Charsets
Procedure.i AWPB_MSG_GetCharsetCode(CharsetName.s)
  ProcedureReturn ____MSG_GetCharsetCode(CharsetName) 
EndProcedure
;** awpb_msg_getcharsetname
;* Gibt den Namen des als Code bergebenen Charsets zurck._
;* Falls das Charset unbekannt ist, wird "unknown" zurckgegeben.
;** .CharsetCode.i: Code des Charsets
Procedure.s AWPB_MSG_GetCharsetName(CharsetCode.i)
  ProcedureReturn ____MSG_GetCharsetName(CharsetCode)
EndProcedure
;** awpb_msg_gethtmlcharsetname
;* Gibt den Namen des im HTML-Code verwendeten Charsets zurck._ 
;* Falls das Charset nicht zu ermitteln ist, wird ein leerer String zurckgegeben.
;** .HTMLCode.s: HTML Code
Procedure.s AWPB_MSG_GetHTMLCharsetName(HTMLCode.s)
  ProcedureReturn ____MSG_GetHTMLCharset(HTMLCode)
EndProcedure
;** awpb_msg_gethtmlcharsetcode
;* Gibt den Code des im HTML-Code verwendeten Charsets zurck. _
;* Falls das Charset nicht zu ermitteln ist oder unbekannt ist, wird #AWPB_MSG_CS_UNKNOWN zurckgegeben.
;** .HTMLCode.s: HTML Code
Procedure.i AWPB_MSG_GetHTMLCharsetCode(HTMLCode.s)
  ProcedureReturn ____MSG_GetCharsetCode(____MSG_GetHTMLCharset(HTMLCode))
EndProcedure
;** awpb_msg_getsyscharsetname
;* Gibt den Namen des aktuell verwendeten Charsets des Betriebssystems zurck._ 
;* Im Fehlerfall wird ein leerer String zurckgegeben.
Procedure.s AWPB_MSG_GetSysCharsetName()
  ProcedureReturn ____MSG_GetSysCharset()
EndProcedure
;** awpb_msg_getsyscharsetcode
;* Gibt den Code des aktuell verwendeten Charsets des Betriebssystems zurck._ 
;* Im Fehlerfall wird #AWPB_MSG_CS_UNKNOWN zurckgegeben.
Procedure.i AWPB_MSG_GetSysCharsetCode()
  ProcedureReturn ____MSG_GetCharsetCode(____MSG_GetSysCharset())
EndProcedure
;}
;}
    
; IDE Options = PureBasic 4.51 (Windows - x64)
; CursorPosition = 2102
; FirstLine = 93
; Folding = AAAAAAAAAAAAAAAAAAAAAFAIAAAAAAAA-
; EnableUnicode
; EnableThread
; EnableXP
; CPU = 1