; *****************************
; ** angelZware PB Tools Lib **
; ** ----------------------- **
; ** awsupport.pbi           **
; ** V0.2 (2010/08/26)       **
; ** by Ronny Krger         **
; *****************************
; ** Licence: LGPL V3        **
; *****************************

;**
;* awsupport.pbi_
;* Version 0.2_
;* _
;* Zusatzfunktionen fr PureBasic 4.50+_
;* Lizenz: LGPL V3_
;* _
;* Systemanforderungen:_
;* <table style="text-align: left;" border="0" cellpadding="2" cellspacing="0"><tbody><tr>
;* <td style="vertical-align: top;">Windows</td><td style="vertical-align: top;">[x]</td>
;* <td style="vertical-align: top;">Linux</td><td style="vertical-align: top;">[x]</td>
;* <td style="vertical-align: top;">Mac</td><td style="vertical-align: top;">[ ]</td></tr><tr>
;* <td style="vertical-align: top;">x86</td><td style="vertical-align: top;">[x]</td>
;* <td style="vertical-align: top;">x64</td><td style="vertical-align: top;">[x]</td>
;* <td style="vertical-align: top;">PPC</td><td style="vertical-align: top;">[ ]</td></tr><tr>
;* <td style="vertical-align: top;">ASCII</td><td style="vertical-align: top;">[x]</td>
;* <td style="vertical-align: top;">Unicode</td><td style="vertical-align: top;">[x]</td>
;* <td style="vertical-align: top;"></td><td style="vertical-align: top;"></td></tr></tbody></table>

;{ private functions
;{ constants
#____SUP_TRIM_LEFT  = 1
#____SUP_TRIM_RIGHT = 2
#____SUP_TRIM_BOTH  = #____SUP_TRIM_LEFT | #____SUP_TRIM_RIGHT
;}
;{ Funktionen
; Rckgabe der ist das erste Zeichen und die Lnge (Zeiger auf NewLen.i bergeben) des neuen Abschnittes. Das Original wird nicht verndert.
Procedure.i ____SUP_TrimWSBin(*txt, len.i, *newlen, trimmode.i = #____SUP_TRIM_BOTH)      ; alle nicht druckbaren Zeichen entfernen (ASCII < 33)
  Protected *l, *r, *res
  
  *res = #Null
  If *txt And (len > 0) And *newlen
    *l = *txt                                           ; erstes Zeichen
    *r = *l + len - 1                                   ; letztes Zeichen
    
    If (trimmode & #____SUP_TRIM_LEFT) = #____SUP_TRIM_LEFT
      While (PeekA(*l) < 33) And (*l < *r) : *l + 1 : Wend      ; erstes druckbares Zeichen von links suchen
    EndIf
    If (trimmode & #____SUP_TRIM_RIGHT) = #____SUP_TRIM_RIGHT
      While (PeekA(*r) < 33) And (*r > *l) : *r - 1 : Wend      ; erstes druckbares Zeichen von rechts suchen
    EndIf
    
    If *r = *l
      If PeekA(*l) >= 33
        *res = *l
        len  = 1
      EndIf
    Else
      *res = *l
      len  = *r - *l + 1
    EndIf
    
    PokeI(*newlen, len)
  EndIf
  
  ProcedureReturn *res
EndProcedure
Procedure.s ____SUP_TrimWS(txt.s, trimmode.i = #____SUP_TRIM_BOTH)                        ; alle nicht druckbaren Zeichen entfernen (ASCII < 33)
  Protected *l, *r, test.c, res.s
  
  *l = @txt                                           ; erstes Zeichen
  *r = *l + StringByteLength(txt) - SizeOf(test)      ; letztes Zeichen
  
  If (trimmode & #____SUP_TRIM_LEFT) = #____SUP_TRIM_LEFT
    While (PeekC(*l) < 33) And (*l < *r) : *l + SizeOf(test) : Wend 
  EndIf
  If (trimmode & #____SUP_TRIM_RIGHT) = #____SUP_TRIM_RIGHT
    While (PeekC(*r) < 33) And (*r > *l) : *r - SizeOf(test) : Wend
  EndIf
  
  If *r = *l
    If PeekC(*l) < 33
      res = ""
    Else
      res = Chr(PeekC(*l))      
    EndIf
  Else
    res = PeekS(*l, ((*r - *l) / SizeOf(test)) + 1)
  EndIf
  
  ProcedureReturn res   
EndProcedure
Procedure.s ____SUP_TrimWSQ(txt.s, trimmode.i = #____SUP_TRIM_BOTH)                       ; alle nicht druckbaren Zeichen einschliesslich "" entfernen (ASCII < 33)
  Protected *l, *r, test.c, res.s
  
  *l = @txt                                           ; erstes Zeichen
  *r = *l + StringByteLength(txt) - SizeOf(test)      ; letztes Zeichen
  
  If (trimmode & #____SUP_TRIM_LEFT) = #____SUP_TRIM_LEFT
    While ((PeekC(*l) < 33) Or (PeekC(*l) = 34)) And (*l < *r) : *l + SizeOf(test) : Wend
  EndIf
  If (trimmode & #____SUP_TRIM_RIGHT) = #____SUP_TRIM_RIGHT
    While ((PeekC(*r) < 33) Or (PeekC(*r) = 34)) And (*r > *l) : *r - SizeOf(test) : Wend
  EndIf
  
  If *r = *l
    If ((PeekC(*l) < 33) Or (PeekC(*l) = 34))
      res = ""
    Else  
      res = Chr(PeekC(*l))
    EndIf
  Else
    res = PeekS(*l, ((*r - *l) / SizeOf(test)) + 1)
  EndIf
  
  ProcedureReturn res   
EndProcedure
Procedure.s ____SUP_TrimWSBS(txt.s, trimmode.i = #____SUP_TRIM_BOTH)                      ; alle nicht druckbaren Zeichen einschliesslich <> entfernen (ASCII < 33)
  Protected *l, *r, test.c, res.s
  
  *l = @txt                                           ; erstes Zeichen
  *r = *l + StringByteLength(txt) - SizeOf(test)      ; letztes Zeichen
  
  If (trimmode & #____SUP_TRIM_LEFT) = #____SUP_TRIM_LEFT
    While ((PeekC(*l) < 33) Or (PeekC(*l) = '<')) And (*l < *r) : *l + SizeOf(test) : Wend
  EndIf
  If (trimmode & #____SUP_TRIM_RIGHT) = #____SUP_TRIM_RIGHT
    While ((PeekC(*r) < 33) Or (PeekC(*r) = '>')) And (*r > *l) : *r - SizeOf(test) : Wend
  EndIf
  
  If *r = *l
    If ((PeekC(*l) < 33) Or (PeekC(*l) = 34))
      res = ""
    Else  
      res = Chr(PeekC(*l))
    EndIf
  Else
    res = PeekS(*l, ((*r - *l) / SizeOf(test)) + 1)
  EndIf
  
  ProcedureReturn res   
EndProcedure
Procedure.s ____MSG_CreateMailAdrList(adr.s, separator.s = ":")   ;- TODO 
  Protected k.i, ex.i, res.s, a.i
  Dim result$(0)
  
  res = ""
  ex  = CreateRegularExpression(#PB_Any, "(?:[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*|"+Chr(34)+"(?:[\x01-\x08\x0b\x0c\x0e-\x1f\x21\x23-\x5b\x5d-\x7f]|\\[\x01-\x09\x0b\x0c\x0e-\x7f])*"+Chr(34)+")@(?:(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?|\[(?:(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?|[a-z0-9-]*[a-z0-9]:(?:[\x01-\x08\x0b\x0c\x0e-\x1f\x21-\x5a\x53-\x7f]|\\[\x01-\x09\x0b\x0c\x0e-\x7f])+)\])")
  If ex
    k = ExtractRegularExpression(ex, adr, result$())
    If k
      res = result$(0)
      For a = 1 To k - 1
        res + separator + result$(a)
      Next a
    EndIf
    FreeRegularExpression(ex)
  EndIf
    
  ProcedureReturn res
EndProcedure
Procedure   ____MSG_CreateMailAdrListList(adr.s, List AdrList.s())  ;- TODO
  ClearList(AdrList())
  
  
EndProcedure
Procedure.i ____MSG_FindLastChar(txt.s, char.c) ; ermittelt das letzte Vorkommen eines Zeichens in einem String
  Protected *txt, len.i, pos.i
  
  len  = Len(txt)
  *txt = @txt + StringByteLength(txt) - SizeOf(char)
  For pos = len To 1 Step -1
    If PeekC(*txt) = char : Break : EndIf
    *txt - SizeOf(char)
  Next pos
  
  ProcedureReturn pos
EndProcedure
Procedure.s ____MSG_BuildPath(path.s, file.s)   ; kombiniert einen Pfad mit einem Dateinamen/Ordnernamen wobei der Delimiter Betriebssystemabhngig korrekt gesetzt wird
  If Len(path) > 0
    If Len(file) > 0
      CompilerSelect #PB_Compiler_OS 
          CompilerCase #PB_OS_Windows
            ReplaceString(path, "/", "\", #PB_String_InPlace)  
            ReplaceString(file, "/", "\", #PB_String_InPlace)  
            If Right(path, 1) <> "\"
              path + "\"
            EndIf  
          CompilerCase #PB_OS_Linux
            ReplaceString(path, "\", "/", #PB_String_InPlace)  
            ReplaceString(file, "\", "/", #PB_String_InPlace)  
            If Right(path, 1) <> "/"
              path + "/"
            EndIf  
      CompilerEndSelect
      path + file
    EndIf  
    ProcedureReturn path
  Else
    ProcedureReturn file
  EndIf
EndProcedure
Procedure.s ____SUP_MD5Str(string.s)
  Protected res.s
  
  CompilerIf #PB_Compiler_Unicode
    Protected len.i, *bin
    
    len  = Len(string)
    *bin = AllocateMemory(len + 2)
    If *bin
      PokeS(*bin, string, len, #PB_Ascii)
      res = MD5Fingerprint(*bin, len)
      FreeMemory(*bin)
    EndIf
  CompilerElse
    res = MD5Fingerprint(@string, Len(string))
  CompilerEndIf
  
  ProcedureReturn res
EndProcedure
;}
;}
;{ public functions
;** awpb_trim
;* Entfernt fhrende und abschliessende Zeichen, die < ASCII 33 sind._
;* Funktioniert auch mit Unicode-Strings, es gelten dabei die selben Regeln.
;* Rchgabewert ist der getrimmte String
;** .string: String, der getrimmt werden soll
Procedure.s AWPB_Trim(string.s)
  ProcedureReturn ____SUP_TrimWS(string, #____SUP_TRIM_BOTH)
EndProcedure
;** awpb_trim_left
;* Entfernt fhrende Zeichen, die < ASCII 33 sind._
;* Funktioniert auch mit Unicode-Strings, es gelten dabei die selben Regeln.
;* Rchgabewert ist der getrimmte String
;** .string: String, der getrimmt werden soll
Procedure.s AWPB_Trim_Left(string.s)
  ProcedureReturn ____SUP_TrimWS(string, #____SUP_TRIM_LEFT)
EndProcedure
;** awpb_trim_right
;* Entfernt abschliessende Zeichen, die < ASCII 33 sind._
;* Funktioniert auch mit Unicode-Strings, es gelten dabei die selben Regeln.
;* Rchgabewert ist der getrimmte String
;** .string: String, der getrimmt werden soll
Procedure.s AWPB_Trim_Right(string.s)
  ProcedureReturn ____SUP_TrimWS(string, #____SUP_TRIM_RIGHT)
EndProcedure
;** awpb_md5_string
;* Berechnet die Prfsumme des Strings. Es werden dabei grundstzlich die ASCII-Werte der Zeichen benutzt, auch im Unicode-Modus.
;* Rchgabewert ist die MD5-Prfsumme als String.
;** .string: String, dessen MD5-Prfsumme berechnet werden soll
Procedure.s AWPB_MD5_String(string.s)
  ProcedureReturn ____SUP_MD5Str(string)
EndProcedure
;}
  
; IDE Options = PureBasic 4.51 (Windows - x64)
; CursorPosition = 4
; Folding = Agg
; EnableUnicode
; EnableThread
; EnableXP
; CPU = 1